/**
 * @license
 * (c) 2009-2013 Michael Leibman
 * michael{dot}leibman{at}gmail{dot}com
 * http://github.com/mleibman/slickgrid
 *
 * Distributed under MIT license.
 * All rights reserved.
 *
 * SlickGrid v2.2
 *
 * NOTES:
 *     Cell/row DOM manipulations are done directly bypassing jQuery's DOM manipulation methods.
 *     This increases the speed dramatically, but can only be done safely because there are no event handlers
 *     or data associated with any cell/row DOM nodes.  Cell editors must make sure they implement .destroy()
 *     and do proper cleanup.
 */
if(typeof jQuery==="undefined"){throw"SlickGrid requires jquery module to be loaded"}if(!jQuery.fn.drag){throw"SlickGrid requires jquery.event.drag module to be loaded"}if(typeof Slick==="undefined"){throw"slick.core.js not loaded"}(function($){$.extend(true,window,{Slick:{Grid:SlickGrid}});var scrollbarDimensions;var maxSupportedCssHeight;function SlickGrid(container,data,columns,options){var defaults={explicitInitialization:false,rowHeight:25,defaultColumnWidth:80,enableAddRow:false,leaveSpaceForNewRows:false,editable:false,autoEdit:true,enableCellNavigation:true,enableColumnReorder:true,asyncEditorLoading:false,asyncEditorLoadDelay:100,forceFitColumns:false,enableAsyncPostRender:false,asyncPostRenderDelay:50,enableAsyncPostRenderCleanup:false,asyncPostRenderCleanupDelay:40,autoHeight:false,editorLock:Slick.GlobalEditorLock,showHeaderRow:false,headerRowHeight:25,showFooterRow:false,footerRowHeight:25,showTopPanel:false,topPanelHeight:25,formatterFactory:null,editorFactory:null,cellFlashingCssClass:"flashing",selectedCellCssClass:"selected",multiSelect:true,enableTextSelectionOnCells:false,dataItemColumnValueExtractor:null,frozenBottom:false,frozenColumn:-1,frozenRow:-1,fullWidthRows:false,multiColumnSort:false,defaultFormatter:defaultFormatter,forceSyncScrolling:false,addNewRowCssClass:"new-row"};var columnDefaults={name:"",resizable:true,sortable:false,minWidth:30,rerenderOnResize:false,headerCssClass:null,footerCssClass:null,defaultSortAsc:true,focusable:true,selectable:true};var th;var h;var ph;var n;var cj;var page=0;var offset=0;var vScrollDir=1;var initialized=false;var $container;var uid="slickgrid_"+Math.round(1e6*Math.random());var self=this;var $focusSink,$focusSink2;var $groupHeaders=$();var $headerScroller;var $headers;var $headerRow,$headerRowScroller,$headerRowSpacerL,$headerRowSpacerR;var $footerRow,$footerRowScroller,$footerRowSpacerL,$footerRowSpacerR;var $topPanelScroller;var $topPanel;var $viewport;var $canvas;var $style;var $boundAncestors;var treeColumns;var stylesheet,columnCssRulesL,columnCssRulesR;var viewportH,viewportW;var canvasWidth,canvasWidthL,canvasWidthR;var headersWidth,headersWidthL,headersWidthR;var viewportHasHScroll,viewportHasVScroll;var headerColumnWidthDiff=0,headerColumnHeightDiff=0,cellWidthDiff=0,cellHeightDiff=0,jQueryNewWidthBehaviour=false;var absoluteColumnMinWidth;var hasFrozenRows=false;var frozenRowsHeight=0;var actualFrozenRow=-1;var paneTopH=0;var paneBottomH=0;var viewportTopH=0;var viewportBottomH=0;var topPanelH=0;var headerRowH=0;var footerRowH=0;var tabbingDirection=1;var $activeCanvasNode;var $activeViewportNode;var activePosX;var activeRow,activeCell;var activeCellNode=null;var currentEditor=null;var serializedEditorValue;var editController;var rowsCache={};var renderedRows=0;var numVisibleRows=0;var prevScrollTop=0;var scrollTop=0;var lastRenderedScrollTop=0;var lastRenderedScrollLeft=0;var prevScrollLeft=0;var scrollLeft=0;var selectionModel;var selectedRows=[];var plugins=[];var cellCssClasses={};var columnsById={};var sortColumns=[];var columnPosLeft=[];var columnPosRight=[];var rtl=false;var xLeft="left";var xRight="right";var h_editorLoader=null;var h_render=null;var h_postrender=null;var h_postrenderCleanup=null;var postProcessedRows={};var postProcessToRow=null;var postProcessFromRow=null;var postProcessedCleanupQueue=[];var postProcessgroupId=0;var counter_rows_rendered=0;var counter_rows_removed=0;var rowNodeFromLastMouseWheelEvent;var zombieRowNodeFromLastMouseWheelEvent;var zombieRowCacheFromLastMouseWheelEvent;var zombieRowPostProcessedFromLastMouseWheelEvent;var $paneHeaderL;var $paneHeaderR;var $paneTopL;var $paneTopR;var $paneBottomL;var $paneBottomR;var $headerScrollerL;var $headerScrollerR;var $headerL;var $headerR;var $groupHeadersL;var $groupHeadersR;var $headerRowScrollerL;var $headerRowScrollerR;var $footerRowScrollerL;var $footerRowScrollerR;var $headerRowL;var $headerRowR;var $footerRowL;var $footerRowR;var $topPanelScrollerL;var $topPanelScrollerR;var $topPanelL;var $topPanelR;var $viewportTopL;var $viewportTopR;var $viewportBottomL;var $viewportBottomR;var $canvasTopL;var $canvasTopR;var $canvasBottomL;var $canvasBottomR;var $viewportScrollContainerX;var $viewportScrollContainerY;var $headerScrollContainer;var $headerRowScrollContainer;var $footerRowScrollContainer;function init(){$container=$(container);if($container.length<1){throw new Error("SlickGrid requires a valid container, "+container+" does not exist in the DOM.")}rtl=$(document.body).hasClass("rtl")||$container.css("direction")=="rtl";if(rtl){xLeft="right";xRight="left"}maxSupportedCssHeight=maxSupportedCssHeight||getMaxSupportedCssHeight();scrollbarDimensions=scrollbarDimensions||measureScrollbar();options=$.extend({},defaults,options);validateAndEnforceOptions();columnDefaults.width=options.defaultColumnWidth;treeColumns=new Slick.TreeColumns(columns);columns=treeColumns.extractColumns();columnsById={};for(var e=0;e<columns.length;e++){var o=columns[e]=$.extend({},columnDefaults,columns[e]);columnsById[o.id]=e;if(o.minWidth&&o.width<o.minWidth){o.width=o.minWidth}if(o.maxWidth&&o.width>o.maxWidth){o.width=o.maxWidth}}if(options.enableColumnReorder&&!$.fn.sortable){throw new Error("SlickGrid's 'enableColumnReorder = true' option requires jquery-ui.sortable module to be loaded")}editController={commitCurrentEdit:commitCurrentEdit,cancelCurrentEdit:cancelCurrentEdit};$container.empty().css("overflow","hidden").css("outline",0).addClass(uid).addClass("ui-widget");if(!/relative|absolute|fixed/.test($container.css("position"))){$container.css("position","relative")}$focusSink=$("<div tabIndex='0' hideFocus style='position:fixed;width:0;height:0;top:0;"+xLeft+":0;outline:0;'></div>").appendTo($container);$paneHeaderL=$("<div class='slick-pane slick-pane-header slick-pane-"+xLeft+" tabIndex='0' />").appendTo($container);$paneHeaderR=$("<div class='slick-pane slick-pane-header slick-pane-"+xRight+"' tabIndex='0' />").appendTo($container);$paneTopL=$("<div class='slick-pane slick-pane-top slick-pane-"+xLeft+"' tabIndex='0' />").appendTo($container);$paneTopR=$("<div class='slick-pane slick-pane-top slick-pane-"+xRight+"' tabIndex='0' />").appendTo($container);$paneBottomL=$("<div class='slick-pane slick-pane-bottom slick-pane-"+xLeft+"' tabIndex='0' />").appendTo($container);$paneBottomR=$("<div class='slick-pane slick-pane-bottom slick-pane-"+xRight+"' tabIndex='0' />").appendTo($container);$headerScrollerL=$("<div class='ui-state-default slick-header slick-header-"+xLeft+"' />").appendTo($paneHeaderL);$headerScrollerR=$("<div class='ui-state-default slick-header slick-header-"+xRight+"' />").appendTo($paneHeaderR);$headerScroller=$().add($headerScrollerL).add($headerScrollerR);if(treeColumns.hasDepth()){$groupHeadersL=[],$groupHeadersR=[];for(var t=0;t<treeColumns.getDepth()-1;t++){$groupHeadersL[t]=$("<div class='slick-group-header-columns slick-group-header-columns-"+xLeft+"' style='right:-1000px' />").appendTo($headerScrollerL);$groupHeadersR[t]=$("<div class='slick-group-header-columns slick-group-header-columns-"+xRight+"' style='right:-1000px' />").appendTo($headerScrollerR)}$groupHeaders=$().add($groupHeadersL).add($groupHeadersR)}$headerL=$("<div class='slick-header-columns slick-header-columns-"+xLeft+"' style='"+xLeft+":-1000px' />").appendTo($headerScrollerL);$headerR=$("<div class='slick-header-columns slick-header-columns-"+xRight+"' style='"+xLeft+":-1000px' />").appendTo($headerScrollerR);$headers=$().add($headerL).add($headerR);$headerRowScrollerL=$("<div class='ui-state-default slick-headerrow' />").appendTo($paneTopL);$headerRowScrollerR=$("<div class='ui-state-default slick-headerrow' />").appendTo($paneTopR);$headerRowScroller=$().add($headerRowScrollerL).add($headerRowScrollerR);$headerRowSpacerL=$("<div style='display:block;height:1px;position:absolute;top:0;"+xLeft+":0;'></div>").css("width",getCanvasWidth()+scrollbarDimensions.width+"px").appendTo($headerRowScrollerL);$headerRowSpacerR=$("<div style='display:block;height:1px;position:absolute;top:0;"+xLeft+":0;'></div>").css("width",getCanvasWidth()+scrollbarDimensions.width+"px").appendTo($headerRowScrollerR);$headerRowL=$("<div class='slick-headerrow-columns slick-headerrow-columns-"+xLeft+"' />").appendTo($headerRowScrollerL);$headerRowR=$("<div class='slick-headerrow-columns slick-headerrow-columns-"+xRight+"' />").appendTo($headerRowScrollerR);$headerRow=$().add($headerRowL).add($headerRowR);$topPanelScrollerL=$("<div class='ui-state-default slick-top-panel-scroller' />").appendTo($paneTopL);$topPanelScrollerR=$("<div class='ui-state-default slick-top-panel-scroller' />").appendTo($paneTopR);$topPanelScroller=$().add($topPanelScrollerL).add($topPanelScrollerR);$topPanelL=$("<div class='slick-top-panel' style='width:10000px' />").appendTo($topPanelScrollerL);$topPanelR=$("<div class='slick-top-panel' style='width:10000px' />").appendTo($topPanelScrollerR);$topPanel=$().add($topPanelL).add($topPanelR);if(!options.showTopPanel){$topPanelScroller.hide()}if(!options.showHeaderRow){$headerRowScroller.hide()}$viewportTopL=$("<div class='slick-viewport slick-viewport-top slick-viewport-"+xLeft+"' tabIndex='0' hideFocus />").appendTo($paneTopL);$viewportTopR=$("<div class='slick-viewport slick-viewport-top slick-viewport-"+xRight+"' tabIndex='0' hideFocus />").appendTo($paneTopR);$viewportBottomL=$("<div class='slick-viewport slick-viewport-bottom slick-viewport-"+xLeft+"' tabIndex='0' hideFocus />").appendTo($paneBottomL);$viewportBottomR=$("<div class='slick-viewport slick-viewport-bottom slick-viewport-"+xRight+"' tabIndex='0' hideFocus />").appendTo($paneBottomR);$viewport=$().add($viewportTopL).add($viewportTopR).add($viewportBottomL).add($viewportBottomR);$activeViewportNode=$viewportTopL;$canvasTopL=$("<div class='grid-canvas grid-canvas-top grid-canvas-"+xLeft+"' tabIndex='0' hideFocus />").appendTo($viewportTopL);$canvasTopR=$("<div class='grid-canvas grid-canvas-top grid-canvas-"+xRight+"' tabIndex='0' hideFocus />").appendTo($viewportTopR);$canvasBottomL=$("<div class='grid-canvas grid-canvas-bottom grid-canvas-"+xLeft+"' tabIndex='0' hideFocus />").appendTo($viewportBottomL);$canvasBottomR=$("<div class='grid-canvas grid-canvas-bottom grid-canvas-"+xRight+"' tabIndex='0' hideFocus />").appendTo($viewportBottomR);$canvas=$().add($canvasTopL).add($canvasTopR).add($canvasBottomL).add($canvasBottomR);$activeCanvasNode=$canvasTopL;$footerRowScrollerR=$("<div class='ui-state-default slick-footerrow' />").appendTo($paneTopR);$footerRowScrollerL=$("<div class='ui-state-default slick-footerrow' />").appendTo($paneTopL);$footerRowScroller=$().add($footerRowScrollerL).add($footerRowScrollerR);$footerRowSpacerL=$("<div style='display:block;height:1px;position:absolute;top:0;"+xLeft+":0;'></div>").css("width",getCanvasWidth()+scrollbarDimensions.width+"px").appendTo($footerRowScrollerL);$footerRowSpacerR=$("<div style='display:block;height:1px;position:absolute;top:0;"+xLeft+":0;'></div>").css("width",getCanvasWidth()+scrollbarDimensions.width+"px").appendTo($footerRowScrollerR);$footerRowL=$("<div class='slick-footerrow-columns slick-footerrow-columns-"+xLeft+"' />").appendTo($footerRowScrollerL);$footerRowR=$("<div class='slick-footerrow-columns slick-footerrow-columns-"+xRight+"' />").appendTo($footerRowScrollerR);$footerRow=$().add($footerRowL).add($footerRowR);if(!options.showFooterRow){$footerRowScroller.hide()}$focusSink2=$focusSink.clone().appendTo($container);if(!options.explicitInitialization){finishInitialization()}bindToData()}function finishInitialization(){if(!initialized){initialized=true;getViewportWidth();getViewportHeight();measureCellPaddingAndBorder();disableSelection($headers);if(!options.enableTextSelectionOnCells){$viewport.bind("selectstart.ui",function(e){return $(e.target).is("input,textarea")})}setFrozenOptions();setPaneVisibility();setScroller();setOverflow();updateColumnCaches();createColumnHeaders();createColumnGroupHeaders();createColumnFooter();setupColumnSort();createCssRules();resizeCanvas();bindAncestorScrollEvents();$container.bind("resize.slickgrid",resizeCanvas);$viewport.on("scroll",handleScroll);if(jQuery.fn.mousewheel&&(options.frozenColumn>-1||hasFrozenRows)){$viewport.on("mousewheel",handleMouseWheel)}$headerScroller.bind("contextmenu",handleHeaderContextMenu).bind("click",handleHeaderClick).delegate(".slick-header-column","mouseenter",handleHeaderMouseEnter).delegate(".slick-header-column","mouseleave",handleHeaderMouseLeave);$headerRowScroller.bind("scroll",handleHeaderRowScroll);$footerRowScroller.bind("scroll",handleFooterRowScroll);$focusSink.add($focusSink2).bind("keydown",handleKeyDown);$canvas.bind("keydown",handleKeyDown).bind("click",handleClick).bind("dblclick",handleDblClick).bind("contextmenu",handleContextMenu).bind("draginit",handleDragInit).bind("dragstart",{distance:3},handleDragStart).bind("drag",handleDrag).bind("dragend",handleDragEnd).delegate(".slick-cell","mouseenter",handleMouseEnter).delegate(".slick-cell","mouseleave",handleMouseLeave);if(navigator.userAgent.toLowerCase().match(/webkit/)&&navigator.userAgent.toLowerCase().match(/macintosh/)){$canvas.on("mousewheel",handleMouseWheel)}}}function hasFrozenColumns(){return options.frozenColumn>-1}function registerPlugin(e){plugins.unshift(e);e.init(self)}function unregisterPlugin(e){for(var o=plugins.length;o>=0;o--){if(plugins[o]===e){if(plugins[o].destroy){plugins[o].destroy()}plugins.splice(o,1);break}}}function setSelectionModel(e){if(selectionModel){selectionModel.onSelectedRangesChanged.unsubscribe(handleSelectedRangesChanged);if(selectionModel.destroy){selectionModel.destroy()}}selectionModel=e;if(selectionModel){selectionModel.init(self);selectionModel.onSelectedRangesChanged.subscribe(handleSelectedRangesChanged)}}function getSelectionModel(){return selectionModel}function getCanvasNode(){return $canvas[0]}function getActiveCanvasNode(e){setActiveCanvasNode(e);return $activeCanvasNode[0]}function getCanvases(){return $canvas}function setActiveCanvasNode(e){if(e){$activeCanvasNode=$(e.target).closest(".grid-canvas")}}function getViewportNode(){return $viewport[0]}function getActiveViewportNode(e){setActiveViewPortNode(e);return $activeViewportNode[0]}function setActiveViewportNode(e){if(e){$activeViewportNode=$(e.target).closest(".slick-viewport")}}function measureScrollbar(){var e=$("<div style='position:absolute; top:-10000px; "+xLeft+":-10000px; width:100px; height:100px; overflow:scroll;'></div>").appendTo("body");var o={width:Math.round(e.width()-e[0].clientWidth),height:Math.round(e.height()-e[0].clientHeight)};e.remove();return o}function getHeadersWidth(){headersWidth=headersWidthL=headersWidthR=0;for(var e=0,o=columns.length;e<o;e++){var t=columns[e].width;if(options.frozenColumn>-1&&e>options.frozenColumn){headersWidthR+=t}else{headersWidthL+=t}}if(hasFrozenColumns()){headersWidthL=headersWidthL+1e3;headersWidthR=Math.max(headersWidthR,viewportW)+headersWidthL;headersWidthR+=scrollbarDimensions.width}else{headersWidthL+=scrollbarDimensions.width;headersWidthL=Math.max(headersWidthL,viewportW)+1e3}headersWidth=headersWidthL+headersWidthR}function getHeadersWidthL(){headersWidthL=0;columns.forEach(function(e,o){if(!(options.frozenColumn>-1&&o>options.frozenColumn))headersWidthL+=e.width});if(hasFrozenColumns()){headersWidthL+=1e3}else{headersWidthL+=scrollbarDimensions.width;headersWidthL=Math.max(headersWidthL,viewportW)+1e3}return headersWidthL}function getHeadersWidthR(){headersWidthR=0;columns.forEach(function(e,o){if(options.frozenColumn>-1&&o>options.frozenColumn)headersWidthR+=e.width});if(hasFrozenColumns()){headersWidthR=Math.max(headersWidthR,viewportW)+getHeadersWidthL();headersWidthR+=scrollbarDimensions.width}return headersWidthR}function getCanvasWidth(){var e=viewportHasVScroll?viewportW-scrollbarDimensions.width:viewportW;var o=columns.length;canvasWidthL=canvasWidthR=0;while(o--){if(hasFrozenColumns()&&o>options.frozenColumn){canvasWidthR+=columns[o].width}else{canvasWidthL+=columns[o].width}}var t=canvasWidthL+canvasWidthR;return options.fullWidthRows?Math.max(t,e):t}function updateCanvasWidth(e){var o=canvasWidth;var t=canvasWidthL;var r=canvasWidthR;var n;canvasWidth=getCanvasWidth();n=canvasWidth!==o||canvasWidthL!==t||canvasWidthR!==r;if(n||hasFrozenColumns()||hasFrozenRows){$canvasTopL.width(canvasWidthL);getHeadersWidth();$headerL.width(headersWidthL);$headerR.width(headersWidthR);if(hasFrozenColumns()){$canvasTopR.width(canvasWidthR);$paneHeaderL.width(canvasWidthL);$paneHeaderR.css(xLeft,canvasWidthL);$paneHeaderR.css("width",viewportW-canvasWidthL);$paneTopL.width(canvasWidthL);$paneTopR.css(xLeft,canvasWidthL);$paneTopR.css("width",viewportW-canvasWidthL);$headerRowScrollerL.width(canvasWidthL);$headerRowScrollerR.width(viewportW-canvasWidthL);$headerRowL.width(canvasWidthL);$headerRowR.width(canvasWidthR);$footerRowScrollerL.width(canvasWidthL);$footerRowScrollerR.width(viewportW-canvasWidthL);$footerRowL.width(canvasWidthL);$footerRowR.width(canvasWidthR);$viewportTopL.width(canvasWidthL);$viewportTopR.width(viewportW-canvasWidthL);if(hasFrozenRows){$paneBottomL.width(canvasWidthL);$paneBottomR.css(xLeft,canvasWidthL);$viewportBottomL.width(canvasWidthL);$viewportBottomR.width(viewportW-canvasWidthL);$canvasBottomL.width(canvasWidthL);$canvasBottomR.width(canvasWidthR)}}else{$paneHeaderL.width("100%");$paneTopL.width("100%");$headerRowScrollerL.width("100%");$headerRowL.width(canvasWidth);$footerRowScrollerL.width("100%");$footerRowL.width(canvasWidth);$viewportTopL.width("100%");if(hasFrozenRows){$viewportBottomL.width("100%");$canvasBottomL.width(canvasWidthL)}}viewportHasHScroll=canvasWidth>viewportW-scrollbarDimensions.width}$headerRowSpacerL.width(canvasWidth+(viewportHasVScroll?scrollbarDimensions.width:0));$headerRowSpacerR.width(canvasWidth+(viewportHasVScroll?scrollbarDimensions.width:0));$footerRowSpacerL.width(canvasWidth+(viewportHasVScroll?scrollbarDimensions.width:0));$footerRowSpacerR.width(canvasWidth+(viewportHasVScroll?scrollbarDimensions.width:0));if(n||e){applyColumnWidths()}}function disableSelection(e){if(e&&e.jquery){e.attr("unselectable","on").css("MozUserSelect","none").bind("selectstart.ui",function(){return false})}}function getMaxSupportedCssHeight(){var e=1e6;var o=navigator.userAgent.toLowerCase().match(/firefox/)?6e6:1e9;var t=$("<div style='display:none' />").appendTo(document.body);while(true){var r=e*2;t.css("height",r);if(r>o||Math.round(t.height())!==r){break}else{e=r}}t.remove();return e}function bindAncestorScrollEvents(){var e=hasFrozenRows&&!options.frozenBottom?$canvasBottomL[0]:$canvasTopL[0];while((e=e.parentNode)!=document.body&&e!=null){if(e==$viewportTopL[0]||e.scrollWidth!=e.clientWidth||e.scrollHeight!=e.clientHeight){var o=$(e);if(!$boundAncestors){$boundAncestors=o}else{$boundAncestors=$boundAncestors.add(o)}o.bind("scroll."+uid,handleActiveCellPositionChange)}}}function unbindAncestorScrollEvents(){if(!$boundAncestors){return}$boundAncestors.unbind("scroll."+uid);$boundAncestors=null}function updateColumnHeader(e,o,t){if(!initialized){return}var r=getColumnIndex(e);if(r==null){return}var n=columns[r];var l=$headers.children().eq(r);if(l){if(o!==undefined){columns[r].name=o}if(t!==undefined){columns[r].toolTip=t}trigger(self.onBeforeHeaderCellDestroy,{node:l[0],column:n,grid:self});l.attr("title",t||"").children().eq(0).html(o);trigger(self.onHeaderCellRendered,{node:l[0],column:n,grid:self})}}function getHeaderRow(){return hasFrozenColumns()?$headerRow:$headerRow[0]}function getHeaderRowColumn(e){var o=getColumnIndex(e);var t;if(hasFrozenColumns()){if(o<=options.frozenColumn){t=$headerRowL}else{t=$headerRowR;o-=options.frozenColumn+1}}else{t=$headerRowL}var r=t.children().eq(o);return r&&r[0]}function getFooterRow(){return hasFrozenColumns()?$footerRow:$footerRow[0]}function getFooterRowColumn(e){var o=getColumnIndex(e);var t;if(hasFrozenColumns()){if(o<=options.frozenColumn){t=$footerRowL}else{t=$footerRowR;o-=options.frozenColumn+1}}else{t=$footerRowL}var r=t.children().eq(o);return r&&r[0]}function createColumnFooter(){$footerRow.find(".slick-footerrow-column").each(function(){var e=$(this).data("column");if(e){trigger(self.onBeforeFooterRowCellDestroy,{node:this,column:e})}});$footerRowL.empty();$footerRowR.empty();for(var e=0;e<columns.length;e++){var o=columns[e];var t=$("<div class='ui-state-default slick-footerrow-column l"+e+" r"+e+"'></div>").data("column",o).addClass(o.footerCssClass||o.cssClass||"").addClass(hasFrozenColumns()&&e<=options.frozenColumn?"frozen":"").appendTo(hasFrozenColumns()&&e>options.frozenColumn?$footerRowR:$footerRowL);trigger(self.onFooterRowCellRendered,{node:t[0],column:o,grid:self})}}function groupTotalText(e,o,t){var r=t.substr(0,1).toUpperCase()+t.substr(1);text=window.Q&&Q.tryGetText&&Q.tryGetText(r)||r;var n=e[t][o.field];if(typeof n=="number"&&Q&&Q.formatNumber){if(o.sourceItem&&o.sourceItem.displayFormat){n=Q.formatNumber(n,o.sourceItem.displayFormat)}else n=Q.formatNumber(n,"#,##0.##")}return"<span class='aggregate agg-"+t+"'  title='"+text+"'>"+n+"</span>"}function groupTotalsFormatter(e,o){if(!e||!o)return"";var t=null;["sum","avg","min","max","cnt"].forEach(function(r){if(t==null&&e[r]&&e[r][o.field]!=null){t=groupTotalText(e,o,r);return false}});return t||""}function createColumnGroupHeaders(){var e=0;var o=false;if(!treeColumns.hasDepth())return;for(var t=0;t<$groupHeadersL.length;t++){$groupHeadersL[t].empty();$groupHeadersR[t].empty();var r=treeColumns.getColumnsInDepth(t);for(var n in r){var l=r[n];e+=l.extractColumns().length;if(hasFrozenColumns()&&t==0&&e-1===options.frozenColumn)o=true;$("<div class='ui-state-default slick-group-header-column' />").html("<span class='slick-column-name'>"+l.name+"</span>").attr("id",""+uid+l.id).attr("title",l.toolTip||"").data("column",l).addClass(l.headerCssClass||"").addClass(hasFrozenColumns()&&e-1>options.frozenColumn?"frozen":"").appendTo(hasFrozenColumns()&&e-1>options.frozenColumn?$groupHeadersR[t]:$groupHeadersL[t])}if(hasFrozenColumns()&&t==0&&!o){$groupHeadersL[t].empty();$groupHeadersR[t].empty();alert("All columns of group should to be grouped!");break}}applyColumnGroupHeaderWidths()}function createColumnHeaders(){function e(){$(this).addClass("ui-state-hover")}function o(){$(this).removeClass("ui-state-hover")}$headers.find(".slick-header-column").each(function(){var e=$(this).data("column");if(e){trigger(self.onBeforeHeaderCellDestroy,{node:this,column:e,grid:self})}});$headerL.empty();$headerR.empty();getHeadersWidth();$headerL.width(headersWidthL);$headerR.width(headersWidthR);$headerRow.find(".slick-headerrow-column").each(function(){var e=$(this).data("column");if(e){trigger(self.onBeforeHeaderRowCellDestroy,{node:this,column:e})}});$headerRowL.empty();$headerRowR.empty();for(var t=0;t<columns.length;t++){var r=columns[t];var n=hasFrozenColumns()?t<=options.frozenColumn?$headerL:$headerR:$headerL;var l=hasFrozenColumns()?t<=options.frozenColumn?$headerRowL:$headerRowR:$headerRowL;var i=$("<div class='ui-state-default slick-header-column' />").html("<span class='slick-column-name'>"+r.name+"</span>").width(r.width-headerColumnWidthDiff).attr("id",""+uid+r.id).attr("title",r.toolTip||"").data("column",r).addClass(r.headerCssClass||"").addClass(hasFrozenColumns()&&t<=options.frozenColumn?"frozen":"").appendTo(n);if(options.enableColumnReorder||r.sortable){i.on("mouseenter",e).on("mouseleave",o)}if(r.sortable){i.addClass("slick-header-sortable");i.append("<span class='slick-sort-indicator' />")}trigger(self.onHeaderCellRendered,{node:i[0],column:r,grid:self});if(options.showHeaderRow){var a=$("<div class='ui-state-default slick-headerrow-column l"+t+" r"+t+"'></div>").data("column",r).appendTo(l);trigger(self.onHeaderRowCellRendered,{node:a[0],column:r,grid:self})}}setSortColumns(sortColumns);setupColumnResize();if(options.enableColumnReorder){setupColumnReorder()}}function setupColumnSort(){$headers.click(function(e){e.metaKey=e.metaKey||e.ctrlKey;if($(e.target).hasClass("slick-resizable-handle")){return}var o=$(e.target).closest(".slick-header-column");if(!o.length){return}var t=o.data("column");if(t.sortable){if(!getEditorLock().commitCurrentEdit()){return}var r=null;var n=0;for(;n<sortColumns.length;n++){if(sortColumns[n].columnId==t.id){r=sortColumns[n];r.sortAsc=!r.sortAsc;break}}if(e.metaKey&&options.multiColumnSort){if(r){sortColumns.splice(n,1)}}else{if(!e.shiftKey&&!e.metaKey||!options.multiColumnSort){sortColumns=[]}if(!r){r={columnId:t.id,sortAsc:t.defaultSortAsc};sortColumns.push(r)}else if(sortColumns.length==0){sortColumns.push(r)}}setSortColumns(sortColumns);if(!options.multiColumnSort){trigger(self.onSort,{multiColumnSort:false,sortCol:t,sortAsc:r.sortAsc,grid:self},e)}else{trigger(self.onSort,{multiColumnSort:true,sortCols:$.map(sortColumns,function(e){return{sortCol:columns[getColumnIndex(e.columnId)],sortAsc:e.sortAsc}}),grid:self},e)}}})}function currentPositionInHeader(e){var o=0;$headers.find(".slick-header-column").each(function(t){if(this.id==e){o=t;return false}});return o}function limitPositionInGroup(e){var o,t=0,r=0;treeColumns.getColumnsInDepth($groupHeadersL.length-1).some(function(n){t=r;r+=n.columns.length;n.columns.some(function(t){if(t.id===e)o=n;return o});return o});r--;return{start:t,end:r,group:o}}function remove(e,o){var t=e.lastIndexOf(o);if(t>-1){e.splice(t,1);remove(e,o)}}function columnPositionValidInGroup(e){var o=currentPositionInHeader(e[0].id);var t=limitPositionInGroup(e.data("column").id);var r=t.start<=o&&o<=t.end;return{limit:t,valid:r,message:r?"":'Column "'.concat(e.text(),'" can be reordered only within the "',t.group.name,'" group!')}}function setupColumnReorder(){$headers.filter(":ui-sortable").sortable("destroy");var e=null;function o(){$viewportScrollContainerX[0].scrollLeft=$viewportScrollContainerX[0].scrollLeft+10}function t(){$viewportScrollContainerX[0].scrollLeft=$viewportScrollContainerX[0].scrollLeft-10}var r;$headers.sortable({containment:"parent",distance:3,axis:"x",cursor:"default",tolerance:"intersection",helper:"clone",placeholder:"slick-sortable-placeholder ui-state-default slick-header-column",start:function(e,o){o.placeholder.width(o.helper.outerWidth()-headerColumnWidthDiff);r=!hasFrozenColumns()||o.placeholder.offset()[xLeft]+Math.round(o.placeholder.width())>$viewportScrollContainerX.offset()[xLeft];$(o.helper).addClass("slick-header-column-active")},beforeStop:function(e,o){$(o.helper).removeClass("slick-header-column-active")},sort:function(n,l){if(r&&n.originalEvent.pageX>$container[0].clientWidth){if(!e){e=setInterval(o,100)}}else if(r&&n.originalEvent.pageX<$viewportScrollContainerX.offset().left){if(!e){e=setInterval(t,100)}}else{clearInterval(e);e=null}},stop:function(o,t){var r=false;clearInterval(e);e=null;var n=null;if(treeColumns.hasDepth()){var l=columnPositionValidInGroup(t.item);n=l.limit;r=!l.valid;if(r)alert(l.message)}if(r||!getEditorLock().commitCurrentEdit()){$(this).sortable("cancel");return}var i=$headerL.sortable("toArray");i=i.concat($headerR.sortable("toArray"));var a=[];for(var s=0;s<i.length;s++){a.push(columns[getColumnIndex(i[s].replace(uid,""))])}setColumns(a);trigger(self.onColumnsReordered,{impactedColumns:getImpactedColumns(n),grid:self});o.stopPropagation();setupColumnResize()}})}function getImpactedColumns(e){var o=[];if(e!=undefined){for(var t=e.start;t<=e.end;t++){o.push(columns[t])}}else{o=columns}return o}function setupColumnResize(){var e,o,t,r,n,l,i,a,s,d;l=$headers.children();l.find(".slick-resizable-handle").remove();l.each(function(e,o){if(columns[e].resizable){if(s===undefined){s=e}d=e}});if(s===undefined){return}l.each(function(c,u){if(c<s||options.forceFitColumns&&c>=d){return}e=$(u);$("<div class='slick-resizable-handle' />").appendTo(u).bind("dragstart",function(e,t){if(!getEditorLock().commitCurrentEdit()){return false}n=e.pageX;$(this).parent().addClass("slick-header-column-active");var s=null,d=null;l.each(function(e,o){columns[e].previousWidth=$(o).outerWidth()});if(options.forceFitColumns){s=0;d=0;for(o=c+1;o<l.length;o++){r=columns[o];if(r.resizable){if(d!==null){if(r.maxWidth){d+=r.maxWidth-r.previousWidth}else{d=null}}s+=r.previousWidth-Math.max(r.minWidth||0,absoluteColumnMinWidth)}}}var u=0,h=0;for(o=0;o<=c;o++){r=columns[o];if(r.resizable){if(h!==null){if(r.maxWidth){h+=r.maxWidth-r.previousWidth}else{h=null}}u+=r.previousWidth-Math.max(r.minWidth||0,absoluteColumnMinWidth)}}if(s===null){s=1e5}if(u===null){u=1e5}if(d===null){d=1e5}if(h===null){h=1e5}a=n+Math.min(s,h);i=n-Math.min(u,d)}).bind("drag",function(e,s){var d,u=Math.min(a,Math.max(i,e.pageX))-n,h;if(u<0){h=u;var f=0,p=0;for(o=c;o>=0;o--){r=columns[o];if(r.resizable){d=Math.max(r.minWidth||0,absoluteColumnMinWidth);if(h&&r.previousWidth+h<d){h+=r.previousWidth-d;r.width=d}else{r.width=r.previousWidth+h;h=0}}}for(t=0;t<=c;t++){r=columns[t];if(hasFrozenColumns()&&t>options.frozenColumn){p+=r.width}else{f+=r.width}}if(options.forceFitColumns){h=-u;for(o=c+1;o<l.length;o++){r=columns[o];if(r.resizable){if(h&&r.maxWidth&&r.maxWidth-r.previousWidth<h){h-=r.maxWidth-r.previousWidth;r.width=r.maxWidth}else{r.width=r.previousWidth+h;h=0}if(hasFrozenColumns()&&o>options.frozenColumn){p+=r.width}else{f+=r.width}}}}else{for(o=c+1;o<l.length;o++){r=columns[o];if(hasFrozenColumns()&&o>options.frozenColumn){p+=r.width}else{f+=r.width}}}}else{h=u;var f=0,p=0;for(o=c;o>=0;o--){r=columns[o];if(r.resizable){if(h&&r.maxWidth&&r.maxWidth-r.previousWidth<h){h-=r.maxWidth-r.previousWidth;r.width=r.maxWidth}else{r.width=r.previousWidth+h;h=0}}}for(t=0;t<=c;t++){r=columns[t];if(hasFrozenColumns()&&t>options.frozenColumn){p+=r.width}else{f+=r.width}}if(options.forceFitColumns){h=-u;for(o=c+1;o<l.length;o++){r=columns[o];if(r.resizable){d=Math.max(r.minWidth||0,absoluteColumnMinWidth);if(h&&r.previousWidth+h<d){h+=r.previousWidth-d;r.width=d}else{r.width=r.previousWidth+h;h=0}if(hasFrozenColumns()&&o>options.frozenColumn){p+=r.width}else{f+=r.width}}}}else{for(o=c+1;o<l.length;o++){r=columns[o];if(hasFrozenColumns()&&o>options.frozenColumn){p+=r.width}else{f+=r.width}}}}if(hasFrozenColumns()&&f!=canvasWidthL){$headerL.width(f+1e3);$paneHeaderR.css(xLeft,f)}applyColumnHeaderWidths();applyColumnGroupHeaderWidths();if(options.syncColumnCellResize){applyColumnWidths()}}).bind("dragend",function(e,t){var n;$(this).parent().removeClass("slick-header-column-active");for(o=0;o<l.length;o++){r=columns[o];n=$(l[o]).outerWidth();if(r.previousWidth!==n&&r.rerenderOnResize){invalidateAllRows()}}updateCanvasWidth(true);render();trigger(self.onColumnsResized,{grid:self})})})}function getVBoxDelta(e){var o=["borderTopWidth","borderBottomWidth","paddingTop","paddingBottom"];var t=0;$.each(o,function(o,r){t+=parseFloat(e.css(r))||0});return t}function setFrozenOptions(){options.frozenColumn=options.frozenColumn>=0&&options.frozenColumn<columns.length?parseInt(options.frozenColumn):-1;options.frozenRow=options.frozenRow>=0&&options.frozenRow<numVisibleRows?parseInt(options.frozenRow):-1;if(options.frozenRow>-1){hasFrozenRows=true;frozenRowsHeight=options.frozenRow*options.rowHeight;var e=getDataLength()||this.data.length;actualFrozenRow=options.frozenBottom?e-options.frozenRow:options.frozenRow}else{hasFrozenRows=false}}function setPaneVisibility(){if(hasFrozenColumns()){$paneHeaderR.show();$paneTopR.show();if(hasFrozenRows){$paneBottomL.show();$paneBottomR.show()}else{$paneBottomR.hide();$paneBottomL.hide()}}else{$paneHeaderR.hide();$paneTopR.hide();$paneBottomR.hide();if(hasFrozenRows){$paneBottomL.show()}else{$paneBottomR.hide();$paneBottomL.hide()}}}function setOverflow(){$viewportTopL.css({"overflow-x":hasFrozenColumns()?hasFrozenRows?"hidden":"scroll":hasFrozenRows?"hidden":"auto","overflow-y":hasFrozenColumns()?hasFrozenRows?"hidden":"hidden":hasFrozenRows?"scroll":"auto"});$viewportTopR.css({"overflow-x":hasFrozenColumns()?hasFrozenRows?"hidden":"scroll":hasFrozenRows?"hidden":"auto","overflow-y":hasFrozenColumns()?hasFrozenRows?"scroll":"auto":hasFrozenRows?"scroll":"auto"});
$viewportBottomL.css({"overflow-x":hasFrozenColumns()?hasFrozenRows?"scroll":"auto":hasFrozenRows?"auto":"auto","overflow-y":hasFrozenColumns()?hasFrozenRows?"hidden":"hidden":hasFrozenRows?"scroll":"auto"});$viewportBottomR.css({"overflow-x":hasFrozenColumns()?hasFrozenRows?"scroll":"auto":hasFrozenRows?"auto":"auto","overflow-y":hasFrozenColumns()?hasFrozenRows?"auto":"auto":hasFrozenRows?"auto":"auto"})}function setScroller(){if(hasFrozenColumns()){$headerScrollContainer=$headerScrollerR;$headerRowScrollContainer=$headerRowScrollerR;$footerRowScrollContainer=$footerRowScrollerR;if(hasFrozenRows){if(options.frozenBottom){$viewportScrollContainerX=$viewportBottomR;$viewportScrollContainerY=$viewportTopR}else{$viewportScrollContainerX=$viewportScrollContainerY=$viewportBottomR}}else{$viewportScrollContainerX=$viewportScrollContainerY=$viewportTopR}}else{$headerScrollContainer=$headerScrollerL;$headerRowScrollContainer=$headerRowScrollerL;$footerRowScrollContainer=$footerRowScrollerL;if(hasFrozenRows){if(options.frozenBottom){$viewportScrollContainerX=$viewportBottomL;$viewportScrollContainerY=$viewportTopL}else{$viewportScrollContainerX=$viewportScrollContainerY=$viewportBottomL}}else{$viewportScrollContainerX=$viewportScrollContainerY=$viewportTopL}}}function measureCellPaddingAndBorder(){var e;var o=["borderLeftWidth","borderRightWidth","paddingLeft","paddingRight"];var t=["borderTopWidth","borderBottomWidth","paddingTop","paddingBottom"];var r=$.fn.jquery.split(".");jQueryNewWidthBehaviour=r[0]==1&&r[1]>=8||r[0]>=2;e=$("<div class='ui-state-default slick-header-column' style='visibility:hidden'>-</div>").appendTo($headers);headerColumnWidthDiff=headerColumnHeightDiff=0;if(e.css("box-sizing")!="border-box"&&e.css("-moz-box-sizing")!="border-box"&&e.css("-webkit-box-sizing")!="border-box"){$.each(o,function(o,t){headerColumnWidthDiff+=parseFloat(e.css(t))||0});$.each(t,function(o,t){headerColumnHeightDiff+=parseFloat(e.css(t))||0})}e.remove();var n=$("<div class='slick-row' />").appendTo($canvas);e=$("<div class='slick-cell' id='' style='visibility:hidden'>-</div>").appendTo(n);cellWidthDiff=cellHeightDiff=0;if(e.css("box-sizing")!="border-box"&&e.css("-moz-box-sizing")!="border-box"&&e.css("-webkit-box-sizing")!="border-box"){$.each(o,function(o,t){cellWidthDiff+=parseFloat(e.css(t))||0});$.each(t,function(o,t){cellHeightDiff+=parseFloat(e.css(t))||0})}n.remove();absoluteColumnMinWidth=Math.max(headerColumnWidthDiff,cellWidthDiff)}function createCssRules(){$style=$("<style type='text/css' rel='stylesheet' />").appendTo($("head"));var e=options.rowHeight-cellHeightDiff;var o=["."+uid+" .slick-group-header-column { "+xLeft+": 1000px; }","."+uid+" .slick-header-column { "+xLeft+": 1000px; }","."+uid+" .slick-top-panel { height:"+options.topPanelHeight+"px; }","."+uid+" .slick-headerrow-columns { height:"+options.headerRowHeight+"px; }","."+uid+" .slick-cell { height:"+e+"px; }","."+uid+" .slick-row { height:"+options.rowHeight+"px; }","."+uid+" .slick-footerrow-columns { height:"+options.footerRowHeight+"px; }"];for(var t=0;t<columns.length;t++){o.push("."+uid+" .l"+t+" { }");o.push("."+uid+" .r"+t+" { }")}if($style[0].styleSheet){$style[0].styleSheet.cssText=o.join(" ")}else{$style[0].appendChild(document.createTextNode(o.join(" ")))}}function getColumnCssRules(e){if(!stylesheet){var o=document.styleSheets;for(var t=0;t<o.length;t++){if((o[t].ownerNode||o[t].owningElement)==$style[0]){stylesheet=o[t];break}}if(!stylesheet){throw new Error("Cannot find stylesheet.")}columnCssRulesL=[];columnCssRulesR=[];var r=stylesheet.cssRules||stylesheet.rules;var n,l;for(var t=0;t<r.length;t++){var i=r[t].selectorText;if(n=/\.l\d+/.exec(i)){l=parseInt(n[0].substr(2,n[0].length-2),10);columnCssRulesL[l]=r[t]}else if(n=/\.r\d+/.exec(i)){l=parseInt(n[0].substr(2,n[0].length-2),10);columnCssRulesR[l]=r[t]}}}return rtl?{right:columnCssRulesL[e],left:columnCssRulesR[e]}:{left:columnCssRulesL[e],right:columnCssRulesR[e]}}function removeCssRules(){$style.remove();stylesheet=null}function destroy(){getEditorLock().cancelCurrentEdit();trigger(self.onBeforeDestroy,{grid:self});var e=plugins.length;while(e--){unregisterPlugin(plugins[e])}if(options.enableColumnReorder){$headers.filter(":ui-sortable").sortable("destroy")}unbindAncestorScrollEvents();$container.unbind(".slickgrid");removeCssRules();$canvas.unbind("draginit dragstart dragend drag");$container.empty().removeClass(uid)}function trigger(e,o,t){t=t||new Slick.EventData;o=o||{};o.grid=self;return e.notify(o,t,self)}function getEditorLock(){return options.editorLock}function getEditController(){return editController}function getColumnIndex(e){return columnsById[e]}function autosizeColumns(){var e,o,t=[],r=0,n=0,l,i=viewportHasVScroll?viewportW-scrollbarDimensions.width:viewportW;for(e=0;e<columns.length;e++){o=columns[e];t.push(o.width);n+=o.width;if(o.resizable){r+=o.width-Math.max(o.minWidth,absoluteColumnMinWidth)}}l=n;while(n>i&&r){var a=(n-i)/r;for(e=0;e<columns.length&&n>i;e++){o=columns[e];var s=t[e];if(!o.resizable||s<=o.minWidth||s<=absoluteColumnMinWidth){continue}var d=Math.max(o.minWidth,absoluteColumnMinWidth);var c=Math.floor(a*(s-d))||1;c=Math.min(c,s-d);n-=c;r-=c;t[e]-=c}if(l<=n){break}l=n}l=n;while(n<i){var u=i/n;for(e=0;e<columns.length&&n<i;e++){o=columns[e];var h=t[e];var f;if(!o.resizable||o.maxWidth<=h){f=0}else{f=Math.min(Math.floor(u*h)-h,o.maxWidth-h||1e6)||1}n+=f;t[e]+=n<=i?f:0}if(l>=n){break}l=n}var p=false;for(e=0;e<columns.length;e++){if(columns[e].rerenderOnResize&&columns[e].width!=t[e]){p=true}columns[e].width=t[e]}applyColumnHeaderWidths();applyColumnGroupHeaderWidths();updateCanvasWidth(true);if(p){invalidateAllRows();render()}}function applyColumnGroupHeaderWidths(){if(!treeColumns.hasDepth())return;for(var e=$groupHeadersL.length-1;e>=0;e--){var o=treeColumns.getColumnsInDepth(e);$().add($groupHeadersL[e]).add($groupHeadersR[e]).each(function(e){var o=$(this),t=0;o.width(e==0?getHeadersWidthL():getHeadersWidthR());o.children().each(function(){var e=$(this);var r=$(this).data("column");r.width=0;r.columns.forEach(function(){var e=o.next().children(":eq("+t++ +")");r.width+=e.outerWidth()});e.width(r.width-headerColumnWidthDiff)})})}}function applyColumnHeaderWidths(){if(!initialized){return}var e;for(var o=0,t=$headers.children(),r=t.length;o<r;o++){e=$(t[o]);if(jQueryNewWidthBehaviour){if(e.outerWidth()!==columns[o].width){e.outerWidth(columns[o].width)}}else{if(Math.round(e.width())!==columns[o].width-headerColumnWidthDiff){e.width(columns[o].width-headerColumnWidthDiff)}}}updateColumnCaches()}function applyColumnWidths(){var e=0,o,t;for(var r=0;r<columns.length;r++){o=columns[r].width;t=getColumnCssRules(r);t[xLeft].style[xLeft]=e+"px";t[xRight].style[xRight]=(options.frozenColumn!=-1&&r>options.frozenColumn?canvasWidthR:canvasWidthL)-e-o+"px";if(options.frozenColumn==r){e=0}else{e+=columns[r].width}}}function setSortColumn(e,o){setSortColumns([{columnId:e,sortAsc:o}])}function setSortColumns(e){sortColumns=e;var o=$headers.children();o.removeClass("slick-header-column-sorted").find(".slick-sort-indicator").removeClass("slick-sort-indicator-asc slick-sort-indicator-desc");$.each(sortColumns,function(e,t){if(t.sortAsc==null){t.sortAsc=true}var r=getColumnIndex(t.columnId);if(r!=null){o.eq(r).addClass("slick-header-column-sorted").find(".slick-sort-indicator").addClass(t.sortAsc?"slick-sort-indicator-asc":"slick-sort-indicator-desc")}})}function getSortColumns(){return sortColumns}function handleSelectedRangesChanged(e,o){selectedRows=[];var t={};for(var r=0;r<o.length;r++){for(var n=o[r].fromRow;n<=o[r].toRow;n++){if(!t[n]){selectedRows.push(n);t[n]={}}for(var l=o[r].fromCell;l<=o[r].toCell;l++){if(canCellBeSelected(n,l)){t[n][columns[l].id]=options.selectedCellCssClass}}}}setCellCssStyles(options.selectedCellCssClass,t);trigger(self.onSelectedRowsChanged,{rows:getSelectedRows()},e)}function getColumns(){return columns}function updateColumnCaches(){columnPosLeft=[];columnPosRight=[];var e=0;for(var o=0,t=columns.length;o<t;o++){columnPosLeft[o]=e;columnPosRight[o]=e+columns[o].width;if(options.frozenColumn==o){e=0}else{e+=columns[o].width}}}function setColumns(e){var o=new Slick.TreeColumns(e);if(o.hasDepth()){treeColumns=o;columns=treeColumns.extractColumns()}else{columns=e}columnsById={};for(var t=0;t<columns.length;t++){var r=columns[t]=$.extend({},columnDefaults,columns[t]);columnsById[r.id]=t;if(r.minWidth&&r.width<r.minWidth){r.width=r.minWidth}if(r.maxWidth&&r.width>r.maxWidth){r.width=r.maxWidth}}updateColumnCaches();if(initialized){setPaneVisibility();setOverflow();invalidateAllRows();createColumnHeaders();createColumnGroupHeaders();createColumnFooter();removeCssRules();createCssRules();resizeCanvas();updateCanvasWidth();applyColumnWidths();handleScroll()}}function getOptions(){return options}function setOptions(e){if(!getEditorLock().commitCurrentEdit()){return}makeActiveCellNormal();if(options.enableAddRow!==e.enableAddRow){invalidateRow(getDataLength())}options=$.extend(options,e);validateAndEnforceOptions();setFrozenOptions();setScroller();zombieRowNodeFromLastMouseWheelEvent=null;if(e.columns)setColumns(treeColumns.extractColumns());render()}function validateAndEnforceOptions(){if(options.autoHeight){options.leaveSpaceForNewRows=false}}function viewOnRowCountChanged(e,o){updateRowCount();render()}function viewOnRowsChanged(e,o){invalidateRows(o.rows);render();updateFooterTotals()}function viewOnDataChanged(e,o){invalidate();render()}function bindToData(){if(data){data.onRowCountChanged&&data.onRowCountChanged.subscribe(viewOnRowCountChanged);data.onRowsChanged&&data.onRowsChanged.subscribe(viewOnRowsChanged);data.onDataChanged&&data.onDataChanged.subscribe(viewOnDataChanged)}}function unbindFromData(){if(data){data.onRowCountChanged&&data.onRowCountChanged.unsubscribe(viewOnRowCountChanged);data.onRowsChanged&&data.onRowsChanged.unsubscribe(viewOnRowsChanged);data.onDataChanged&&data.onDataChanged.unsubscribe(viewonDataChanged)}}function setData(e,o){unbindFromData();data=e;bindToData();invalidateAllRows();updateRowCount();if(o){scrollTo(0)}}function getData(){return data}function getDataLength(){if(data.getLength){return data.getLength()}else{return data.length}}function getDataLengthIncludingAddNew(){return getDataLength()+(options.enableAddRow?1:0)}function getDataItem(e){if(data.getItem){return data.getItem(e)}else{return data[e]}}function getTopPanel(){return $topPanel[0]}function setTopPanelVisibility(e){if(options.showTopPanel!=e){options.showTopPanel=e;if(e){$topPanelScroller.slideDown("fast",resizeCanvas)}else{$topPanelScroller.slideUp("fast",resizeCanvas)}}}function setHeaderRowVisibility(e){if(options.showHeaderRow!=e){options.showHeaderRow=e;if(e){$headerRowScroller.slideDown("fast",resizeCanvas)}else{$headerRowScroller.slideUp("fast",resizeCanvas)}}}function setFooterRowVisibility(e){if(options.showFooterRow!=e){options.showFooterRow=e;if(e){$footerRowScroller.fadeIn("fast",resizeCanvas)}else{$footerRowScroller.slideDown("fast",resizeCanvas)}}}function getContainerNode(){return $container.get(0)}function getRowTop(e){return options.rowHeight*e-offset}function getRowFromPosition(e){return Math.floor((e+offset)/options.rowHeight)}function scrollTo(e){e=Math.max(e,0);e=Math.min(e,th-Math.round($viewportScrollContainerY.height())+(viewportHasHScroll||hasFrozenColumns()?scrollbarDimensions.height:0));var o=offset;page=Math.min(n-1,Math.floor(e/ph));offset=Math.round(page*cj);var t=e-offset;if(offset!=o){var r=getVisibleRange(t);cleanupRows(r);updateRowPositions()}if(prevScrollTop!=t){vScrollDir=prevScrollTop+o<t+offset?1:-1;lastRenderedScrollTop=scrollTop=prevScrollTop=t;if(hasFrozenColumns()){$viewportTopL[0].scrollTop=t}if(hasFrozenRows){$viewportBottomL[0].scrollTop=$viewportBottomR[0].scrollTop=t}$viewportScrollContainerY[0].scrollTop=t;trigger(self.onViewportChanged,{})}}function defaultFormatter(e,o,t,r,n,l){if(t==null){return""}else{return(t+"").replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;")}}function getFormatter(e,o){var t=data.getItemMetadata&&data.getItemMetadata(e);var r=t&&t.columns&&(t.columns[o.id]||t.columns[getColumnIndex(o.id)]);return r&&r.formatter||t&&t.formatter||o.formatter||options.formatterFactory&&options.formatterFactory.getFormatter(o)||options.defaultFormatter}function callFormatter(e,o,t,r,n){var l;var i=data.getItemMetadata&&data.getItemMetadata(e);i=i&&i.columns;if(i){var a=i[r.id]||i[o];l=getFormatter(e,r)(e,o,t,r,n,a,self)}else{l=getFormatter(e,r)(e,o,t,r,n,null,self)}return l}function getEditor(e,o){var t=columns[o];var r=data.getItemMetadata&&data.getItemMetadata(e);var n=r&&r.columns;if(n&&n[t.id]&&n[t.id].editor!==undefined){return n[t.id].editor}if(n&&n[o]&&n[o].editor!==undefined){return n[o].editor}return t.editor||options.editorFactory&&options.editorFactory.getEditor(t)}function getDataItemValueForColumn(e,o){if(options.dataItemColumnValueExtractor){return options.dataItemColumnValueExtractor(e,o)}return e[o.field]}function appendRowHtml(e,o,t,r,n){var l=getDataItem(t);var i=t<n&&!l;var a="slick-row"+(hasFrozenRows&&t<=options.frozenRow?" frozen":"")+(i?" loading":"")+(t===activeRow?" active":"")+(t%2==1?" odd":" even");if(!l){a+=" "+options.addNewRowCssClass}var s=data.getItemMetadata&&data.getItemMetadata(t);if(s&&s.cssClasses){a+=" "+s.cssClasses}var d=getFrozenRowOffset(t);var c="<div class='ui-widget-content "+a+"' style='top:"+(getRowTop(t)-d)+"px'>";e.push(c);if(hasFrozenColumns()){o.push(c)}var u,h;for(var f=0,p=columns.length;f<p;f++){h=columns[f];u=1;if(s&&s.columns){var v=s.columns[h.id]||s.columns[f];u=v&&v.colspan||1;if(u==="*"){u=p-f}}if(columnPosRight[Math.min(p-1,f+u-1)]>r.leftPx){if(columnPosLeft[f]>r.rightPx){break}if(hasFrozenColumns()&&f>options.frozenColumn){appendCellHtml(o,t,f,u,l)}else{appendCellHtml(e,t,f,u,l)}}else if(hasFrozenColumns()&&f<=options.frozenColumn){appendCellHtml(e,t,f,u,l)}if(u>1){f+=u-1}}e.push("</div>");if(hasFrozenColumns()){o.push("</div>")}}function appendCellHtml(e,o,t,r,n){var l=columns[t];var i="slick-cell l"+t+" r"+Math.min(columns.length-1,t+r-1)+(l.cssClass?" "+l.cssClass:"");if(hasFrozenColumns()&&t<=options.frozenColumn)i+=" frozen";if(o===activeRow&&t===activeCell)i+=" active";for(var a in cellCssClasses){if(cellCssClasses[a][o]&&cellCssClasses[a][o][l.id]){i+=" "+cellCssClasses[a][o][l.id]}}e.push("<div class='"+i+"'>");if(n){var s=getDataItemValueForColumn(n,l);e.push(callFormatter(o,t,s,l,n))}e.push("</div>");rowsCache[o].cellRenderQueue.push(t);rowsCache[o].cellColSpans[t]=r}function cleanupRows(e){for(var o in rowsCache){var t=true;if(hasFrozenRows&&(options.frozenBottom&&o>=actualFrozenRow||!options.frozenBottom&&o<=actualFrozenRow)){t=false}if((o=parseInt(o,10))!==activeRow&&(o<e.top||o>e.bottom)&&t){removeRowFromCache(o)}}options.enableAsyncPostRenderCleanup&&startPostProcessingCleanup()}function invalidate(){updateRowCount();invalidateAllRows();render();updateFooterTotals()}function invalidateAllRows(){if(currentEditor){makeActiveCellNormal()}for(var e in rowsCache){removeRowFromCache(e)}options.enableAsyncPostRenderCleanup&&startPostProcessingCleanup()}function queuePostProcessedRowForCleanup(e,o,t){postProcessgroupId++;for(var r in o){if(o.hasOwnProperty(r)){postProcessedCleanupQueue.push({actionType:"C",groupId:postProcessgroupId,node:e.cellNodesByColumnIdx[r|0],columnIdx:r|0,rowIdx:t})}}postProcessedCleanupQueue.push({actionType:"R",groupId:postProcessgroupId,node:e.rowNode});$(e.rowNode).detach()}function queuePostProcessedCellForCleanup(e,o,t){postProcessedCleanupQueue.push({actionType:"C",groupId:postProcessgroupId,node:e,columnIdx:o,rowIdx:t});$(e).detach()}function removeRowFromCache(e){var o=rowsCache[e];if(!o){return}if(rowNodeFromLastMouseWheelEvent==o.rowNode[0]||hasFrozenColumns()&&rowNodeFromLastMouseWheelEvent==o.rowNode[1]){o.rowNode.hide();zombieRowNodeFromLastMouseWheelEvent=o.rowNode}else{if(options.enableAsyncPostRenderCleanup&&postProcessedRows[e]){queuePostProcessedRowForCleanup(o,postProcessedRows[e],e)}else{o.rowNode.each(function(){this.parentElement.removeChild(this)})}}delete rowsCache[e];delete postProcessedRows[e];renderedRows--;counter_rows_removed++}function invalidateRows(e){var o,t;if(!e||!e.length){return}vScrollDir=0;for(o=0,t=e.length;o<t;o++){if(currentEditor&&activeRow===e[o]){makeActiveCellNormal()}if(rowsCache[e[o]]){removeRowFromCache(e[o])}}options.enableAsyncPostRenderCleanup&&startPostProcessingCleanup()}function invalidateRow(e){invalidateRows([e])}function updateCell(e,o){var t=getCellNode(e,o);if(!t){return}var r=columns[o],n=getDataItem(e);if(currentEditor&&activeRow===e&&activeCell===o){currentEditor.loadValue(n)}else{t.innerHTML=n?callFormatter(e,o,getDataItemValueForColumn(n,r),r,n):"";invalidatePostProcessingResults(e)}}function updateRow(e){var o=rowsCache[e];if(!o){return}ensureCellNodesInRowsCache(e);var t=getDataItem(e);for(var r in o.cellNodesByColumnIdx){if(!o.cellNodesByColumnIdx.hasOwnProperty(r)){continue}r=r|0;var n=columns[r],l=o.cellNodesByColumnIdx[r][0];if(e===activeRow&&r===activeCell&&currentEditor){currentEditor.loadValue(t)}else if(t){l.innerHTML=callFormatter(e,r,getDataItemValueForColumn(t,n),n,t)}else{l.innerHTML=""}}invalidatePostProcessingResults(e)}function getViewportHeight(){if(options.autoHeight){viewportH=options.rowHeight*getDataLengthIncludingAddNew()+(options.frozenColumn==-1?$headers.outerHeight():0)}else{topPanelH=options.showTopPanel?options.topPanelHeight+getVBoxDelta($topPanelScroller):0;headerRowH=options.showHeaderRow?options.headerRowHeight+getVBoxDelta($headerRowScroller):0;footerRowH=options.showFooterRow?options.footerRowHeight+getVBoxDelta($footerRowScroller):0;viewportH=parseFloat($.css($container[0],"height",true))-parseFloat($.css($container[0],"paddingTop",true))-parseFloat($.css($container[0],"paddingBottom",true))-parseFloat($.css($headerScroller[0],"height"))-getVBoxDelta($headerScroller)-topPanelH-headerRowH-footerRowH}numVisibleRows=Math.ceil(viewportH/options.rowHeight)}function getViewportWidth(){viewportW=parseFloat($.css($container[0],"width",true))}function resizeCanvas(){if(!initialized){return}paneTopH=0;paneBottomH=0;viewportTopH=0;viewportBottomH=0;getViewportWidth();getViewportHeight();if(hasFrozenRows){if(options.frozenBottom){paneTopH=viewportH-frozenRowsHeight-scrollbarDimensions.height;paneBottomH=frozenRowsHeight+scrollbarDimensions.height}else{paneTopH=frozenRowsHeight;paneBottomH=viewportH-frozenRowsHeight}}else{paneTopH=viewportH}paneTopH+=topPanelH+headerRowH+footerRowH;if(hasFrozenColumns()&&options.autoHeight){paneTopH+=scrollbarDimensions.height}viewportTopH=paneTopH-topPanelH-headerRowH-footerRowH;if(options.autoHeight){if(hasFrozenColumns()){$container.height(paneTopH+parseFloat($.css($headerScrollerL[0],"height")))}$paneTopL.css("position","relative")}$paneTopL.css({top:Math.round($paneHeaderL.height()),height:paneTopH});var e=$paneTopL.position().top+paneTopH;$viewportTopL.height(viewportTopH);if(hasFrozenColumns()){$paneTopR.css({top:Math.round($paneHeaderL.height()),height:paneTopH});$viewportTopR.height(viewportTopH);if(hasFrozenRows){$paneBottomL.css({top:e,height:paneBottomH});$paneBottomR.css({top:e,height:paneBottomH});$viewportBottomR.height(paneBottomH)}}else{if(hasFrozenRows){$paneBottomL.css({width:"100%",height:paneBottomH});$paneBottomL.css("top",e)}}if(hasFrozenRows){$viewportBottomL.height(paneBottomH);if(options.frozenBottom){$canvasBottomL.height(frozenRowsHeight);if(hasFrozenColumns()){$canvasBottomR.height(frozenRowsHeight)}}else{$canvasTopL.height(frozenRowsHeight);if(hasFrozenColumns()){$canvasTopR.height(frozenRowsHeight)}}}else{$viewportTopR.height(viewportTopH)}if(options.forceFitColumns){autosizeColumns()}updateRowCount();handleScroll();lastRenderedScrollLeft=-1;render()}function updateRowCount(){if(!initialized){return}var e=getDataLengthIncludingAddNew();var o=0;var t=hasFrozenRows&&!options.frozenBottom?Math.round($canvasBottomL.height()):Math.round($canvasTopL.height());if(hasFrozenRows){var o=getDataLength()-options.frozenRow}else{var o=e+(options.leaveSpaceForNewRows?numVisibleRows-1:0)}var r=Math.round($viewportScrollContainerY.height());var l=viewportHasVScroll;viewportHasVScroll=!options.autoHeight&&o*options.rowHeight>r;makeActiveCellNormal();var i=e-1;for(var a in rowsCache){if(a>=i){removeRowFromCache(a)}}options.enableAsyncPostRenderCleanup&&startPostProcessingCleanup();th=Math.max(options.rowHeight*o,r-scrollbarDimensions.height);if(activeCellNode&&activeRow>i){resetActiveCell()}if(th<maxSupportedCssHeight){h=ph=th;n=1;cj=0}else{h=maxSupportedCssHeight;ph=h/100;n=Math.floor(th/ph);cj=(th-h)/(n-1)}if(h!==t){if(hasFrozenRows&&!options.frozenBottom){$canvasBottomL.css("height",h);if(hasFrozenColumns()){$canvasBottomR.css("height",h)}}else{$canvasTopL.css("height",h);$canvasTopR.css("height",h)}scrollTop=$viewportScrollContainerY[0].scrollTop}var s=scrollTop+offset<=th-r;if(th==0||scrollTop==0){page=offset=0}else if(s){scrollTo(scrollTop+offset)}else{scrollTo(th-r)}if(h!=t&&options.autoHeight){resizeCanvas()}if(options.forceFitColumns&&l!=viewportHasVScroll){autosizeColumns()}updateCanvasWidth(false)}function getVisibleRange(e,o){if(e==null){e=scrollTop}if(o==null){o=scrollLeft}return{top:getRowFromPosition(e),bottom:getRowFromPosition(e+viewportH)+1,leftPx:o,rightPx:o+viewportW}}function getRenderedRange(e,o){var t=getVisibleRange(e,o);var r=Math.round(viewportH/options.rowHeight);var n=3;if(vScrollDir==-1){t.top-=r;t.bottom+=n}else if(vScrollDir==1){t.top-=n;t.bottom+=r}else{t.top-=n;t.bottom+=n}t.top=Math.max(0,t.top);t.bottom=Math.min(getDataLengthIncludingAddNew()-1,t.bottom);t.leftPx-=viewportW;t.rightPx+=viewportW;t.leftPx=Math.max(0,t.leftPx);t.rightPx=Math.min(canvasWidth,t.rightPx);return t}function ensureCellNodesInRowsCache(e){var o=rowsCache[e];if(o){if(o.cellRenderQueue.length){var t=o.rowNode.children().last();while(o.cellRenderQueue.length){var r=o.cellRenderQueue.pop();o.cellNodesByColumnIdx[r]=t;t=t.prev();if(t.length==0){t=$(o.rowNode[0]).children().last()}}}}}function cleanUpCells(e,o){if(hasFrozenRows&&(options.frozenBottom&&o>actualFrozenRow||o<=actualFrozenRow)){return}var t=0;var r=rowsCache[o];var n=[];for(var l in r.cellNodesByColumnIdx){if(!r.cellNodesByColumnIdx.hasOwnProperty(l)){continue}l=l|0;if(l<=options.frozenColumn){continue}var i=r.cellColSpans[l];if(columnPosLeft[l]>e.rightPx||columnPosRight[Math.min(columns.length-1,l+i-1)]<e.leftPx){if(!(o==activeRow&&l==activeCell)){n.push(l)}}}var a,s;postProcessgroupId++;while((a=n.pop())!=null){s=r.cellNodesByColumnIdx[a][0];if(options.enableAsyncPostRenderCleanup&&postProcessedRows[o]&&postProcessedRows[o][a]){queuePostProcessedCellForCleanup(s,a,o)}else{s.parentElement.removeChild(s)}delete r.cellColSpans[a];delete r.cellNodesByColumnIdx[a];if(postProcessedRows[o]){delete postProcessedRows[o][a]}t++}}function cleanUpAndRenderCells(e){var o;var t=[];var r=[];var n;var l=0;var i;for(var a=e.top,s=e.bottom;a<=s;a++){o=rowsCache[a];if(!o){continue}ensureCellNodesInRowsCache(a);cleanUpCells(e,a);n=0;var d=data.getItemMetadata&&data.getItemMetadata(a);d=d&&d.columns;var c=getDataItem(a);for(var u=0,h=columns.length;u<h;u++){if(columnPosLeft[u]>e.rightPx){break}if((i=o.cellColSpans[u])!=null){u+=i>1?i-1:0;continue}i=1;if(d){var f=d[columns[u].id]||d[u];i=f&&f.colspan||1;if(i==="*"){i=h-u}}if(columnPosRight[Math.min(h-1,u+i-1)]>e.leftPx){appendCellHtml(t,a,u,i,c);n++}u+=i>1?i-1:0}if(n){l+=n;r.push(a)}}if(!t.length){return}var p=document.createElement("div");p.innerHTML=t.join("");var v;var w;while((v=r.pop())!=null){o=rowsCache[v];var m;while((m=o.cellRenderQueue.pop())!=null){w=$(p).children().last();if(hasFrozenColumns()&&m>options.frozenColumn){$(o.rowNode[1]).append(w)}else{$(o.rowNode[0]).append(w)}o.cellNodesByColumnIdx[m]=w}}}function renderRows(e){var o=[],t=[],r=[],n=false,l=getDataLength();for(var i=e.top,a=e.bottom;i<=a;i++){if(rowsCache[i]||hasFrozenRows&&options.frozenBottom&&i==getDataLength()){continue}renderedRows++;r.push(i);rowsCache[i]={rowNode:null,cellColSpans:[],cellNodesByColumnIdx:[],cellRenderQueue:[]};appendRowHtml(o,t,i,e,l);if(activeCellNode&&activeRow===i){n=true}counter_rows_rendered++}if(!r.length){return}var s=document.createElement("div"),d=document.createElement("div");s.innerHTML=o.join("");d.innerHTML=t.join("");for(var i=0,a=r.length;i<a;i++){if(hasFrozenRows&&r[i]>=actualFrozenRow){if(hasFrozenColumns()){rowsCache[r[i]].rowNode=$().add($(s.firstChild).appendTo($canvasBottomL)).add($(d.firstChild).appendTo($canvasBottomR))}else{rowsCache[r[i]].rowNode=$().add($(s.firstChild).appendTo($canvasBottomL))}}else if(hasFrozenColumns()){rowsCache[r[i]].rowNode=$().add($(s.firstChild).appendTo($canvasTopL)).add($(d.firstChild).appendTo($canvasTopR))}else{rowsCache[r[i]].rowNode=$().add($(s.firstChild).appendTo($canvasTopL))}}if(n){activeCellNode=getCellNode(activeRow,activeCell)}}function startPostProcessing(){if(!options.enableAsyncPostRender){return}clearTimeout(h_postrender);if(options.asyncPostRenderDelay<0){asyncPostProcessRows()}else{h_postrender=setTimeout(asyncPostProcessRows,options.asyncPostRenderDelay)}}function startPostProcessingCleanup(){if(!options.enableAsyncPostRenderCleanup){return}clearTimeout(h_postrenderCleanup);if(options.asyncPostRenderCleanupDelay<0){asyncPostProcessCleanupRows()}else{h_postrenderCleanup=setTimeout(asyncPostProcessCleanupRows,options.asyncPostRenderCleanupDelay)}}function invalidatePostProcessingResults(e){if(options.enableAsyncPostRenderCleanup){for(var o in postProcessedRows[e]){if(postProcessedRows[e].hasOwnProperty(o)){postProcessedRows[e][o]="C"}}}else{delete postProcessedRows[e]}postProcessFromRow=Math.min(postProcessFromRow,e);postProcessToRow=Math.max(postProcessToRow,e);startPostProcessing()}function updateRowPositions(){for(var e in rowsCache){rowsCache[e].rowNode.css("top",getRowTop(e)+"px")}}function updateFooterTotals(){if(!options.showFooterRow||!initialized)return;var e=null;if(data.getGrandTotals){e=data.getGrandTotals()}for(var o=0;o<columns.length;o++){var t=columns[o];var r;if(t.field&&e){r=t.groupTotalsFormatter&&t.groupTotalsFormatter(e,t,self)||self.groupTotalsFormatter&&self.groupTotalsFormatter(e,t,self)||""}$(getFooterRowColumn(t.id)).html(r)}}function render(){if(!initialized){return}var e=getVisibleRange();var o=getRenderedRange();cleanupRows(o);if(lastRenderedScrollLeft!=scrollLeft){if(hasFrozenRows){var t=jQuery.extend(true,{},o);if(options.frozenBottom){t.top=actualFrozenRow;t.bottom=getDataLength()}else{t.top=0;t.bottom=options.frozenRow}cleanUpAndRenderCells(t)}cleanUpAndRenderCells(o)}renderRows(o);if(hasFrozenRows){if(options.frozenBottom){renderRows({top:actualFrozenRow,bottom:getDataLength()-1,leftPx:o.leftPx,rightPx:o.rightPx})}else{renderRows({top:0,bottom:options.frozenRow-1,leftPx:o.leftPx,rightPx:o.rightPx})}}postProcessFromRow=e.top;postProcessToRow=Math.min(getDataLengthIncludingAddNew()-1,e.bottom);startPostProcessing();lastRenderedScrollTop=scrollTop;lastRenderedScrollLeft=scrollLeft;h_render=null}function handleHeaderRowScroll(){var e=$headerRowScrollContainer[0].scrollLeft;if(e!=$viewportScrollContainerX[0].scrollLeft){$viewportScrollContainerX[0].scrollLeft=e}}function handleFooterRowScroll(){var e=$footerRowScrollContainer[0].scrollLeft;if(e!=$viewportScrollContainerX[0].scrollLeft){$viewportScrollContainerX[0].scrollLeft=e}}function handleMouseWheel(e,o,t,r){var n=$(e.target).closest(".slick-row");var l=n[0];if(l!=rowNodeFromLastMouseWheelEvent){var i=n.parents(".grid-canvas");var a=i.hasClass("grid-canvas-"+xLeft);if(zombieRowNodeFromLastMouseWheelEvent&&zombieRowNodeFromLastMouseWheelEvent[a?0:1]!=l){var s=zombieRowNodeFromLastMouseWheelEvent[a||zombieRowNodeFromLastMouseWheelEvent.length==1?0:1];if(options.enableAsyncPostRenderCleanup&&s){queuePostProcessedRowForCleanup(zombieRowCacheFromLastMouseWheelEvent,s)}else{s.parentElement.removeChild(s)}zombieRowCacheFromLastMouseWheelEvent=null;zombieRowNodeFromLastMouseWheelEvent=null;zombieRowPostProcessedFromLastMouseWheelEvent=null;options.enableAsyncPostRenderCleanup&&startPostProcessingCleanup()}rowNodeFromLastMouseWheelEvent=l}scrollTop=Math.max(0,$viewportScrollContainerY[0].scrollTop-r*options.rowHeight);scrollLeft=$viewportScrollContainerX[0].scrollLeft+t*10;var d=_handleScroll(true);if(d)e.preventDefault()}function handleScroll(){scrollTop=$viewportScrollContainerY[0].scrollTop;scrollLeft=$viewportScrollContainerX[0].scrollLeft;return _handleScroll(false)}function _handleScroll(e){var o=$viewportScrollContainerY[0].scrollHeight-$viewportScrollContainerY[0].clientHeight;var t=$viewportScrollContainerY[0].scrollWidth-$viewportScrollContainerY[0].clientWidth;if(scrollTop>o){scrollTop=o}if(scrollLeft>t){scrollLeft=t}var r=Math.abs(scrollTop-prevScrollTop);var l=Math.abs(scrollLeft-prevScrollLeft);if(l){prevScrollLeft=scrollLeft;$viewportScrollContainerX[0].scrollLeft=scrollLeft;$headerScrollContainer[0].scrollLeft=scrollLeft;$topPanelScroller[0].scrollLeft=scrollLeft;$headerRowScrollContainer[0].scrollLeft=scrollLeft;$footerRowScrollContainer[0].scrollLeft=scrollLeft;if(hasFrozenColumns()){if(hasFrozenRows){$viewportTopR[0].scrollLeft=scrollLeft}}else{if(hasFrozenRows){$viewportTopL[0].scrollLeft=scrollLeft}}}if(r){vScrollDir=prevScrollTop<scrollTop?1:-1;prevScrollTop=scrollTop;if(e){$viewportScrollContainerY[0].scrollTop=scrollTop}if(hasFrozenColumns()){if(hasFrozenRows&&!options.frozenBottom){$viewportBottomL[0].scrollTop=scrollTop}else{$viewportTopL[0].scrollTop=scrollTop}}if(r<viewportH){scrollTo(scrollTop+offset)}else{var i=offset;if(h==viewportH){page=0}else{page=Math.min(n-1,Math.floor(scrollTop*((th-viewportH)/(h-viewportH))*(1/ph)))}offset=Math.round(page*cj);if(i!=offset){invalidateAllRows()}}}if(l||r){if(h_render){clearTimeout(h_render)}if(Math.abs(lastRenderedScrollTop-scrollTop)>20||Math.abs(lastRenderedScrollLeft-scrollLeft)>20){if(options.forceSyncScrolling||Math.abs(lastRenderedScrollTop-scrollTop)<viewportH&&Math.abs(lastRenderedScrollLeft-scrollLeft)<viewportW){render()}else{h_render=setTimeout(render,50)}trigger(self.onViewportChanged,{})}}trigger(self.onScroll,{scrollLeft:scrollLeft,scrollTop:scrollTop});if(l||r)return true;return false}function asyncPostProcessRows(){var e=getDataLength();while(postProcessFromRow<=postProcessToRow){var o=vScrollDir>=0?postProcessFromRow++:postProcessToRow--;var t=rowsCache[o];if(!t||o>=e){continue}if(!postProcessedRows[o]){postProcessedRows[o]={}}ensureCellNodesInRowsCache(o);for(var r in t.cellNodesByColumnIdx){if(!t.cellNodesByColumnIdx.hasOwnProperty(r)){continue}r=r|0;var n=columns[r];var l=postProcessedRows[o][r];if(n.asyncPostRender&&l!=="R"){var i=t.cellNodesByColumnIdx[r];if(i){n.asyncPostRender(i,o,getDataItem(o),n,l==="C")}postProcessedRows[o][r]="R"}}if(options.asyncPostRenderDelay>=0){h_postrender=setTimeout(asyncPostProcessRows,options.asyncPostRenderDelay);return}}}function asyncPostProcessCleanupRows(){while(postProcessedCleanupQueue.length>0){var e=postProcessedCleanupQueue[0].groupId;while(postProcessedCleanupQueue.length>0&&postProcessedCleanupQueue[0].groupId==e){var o=postProcessedCleanupQueue.shift();if(o.actionType=="R"){$(o.node).remove()}if(o.actionType=="C"){var t=columns[o.columnIdx];if(t.asyncPostRenderCleanup&&o.node){t.asyncPostRenderCleanup(o.node,o.rowIdx,t)}}}if(options.asyncPostRenderDelay>=0){h_postrenderCleanup=setTimeout(asyncPostProcessCleanupRows,options.asyncPostRenderCleanupDelay);return}}}function updateCellCssStylesOnRenderedRows(e,o){var t,r,n,l;for(var i in rowsCache){l=o&&o[i];n=e&&e[i];if(l){for(r in l){if(!n||l[r]!=n[r]){t=getCellNode(i,getColumnIndex(r));if(t){$(t).removeClass(l[r])}}}}if(n){for(r in n){if(!l||l[r]!=n[r]){t=getCellNode(i,getColumnIndex(r));if(t){$(t).addClass(n[r])}}}}}}function addCellCssStyles(e,o){if(cellCssClasses[e]){throw"addCellCssStyles: cell CSS hash with key '"+e+"' already exists."}cellCssClasses[e]=o;updateCellCssStylesOnRenderedRows(o,null);
trigger(self.onCellCssStylesChanged,{key:e,hash:o})}function removeCellCssStyles(e){if(!cellCssClasses[e]){return}updateCellCssStylesOnRenderedRows(null,cellCssClasses[e]);delete cellCssClasses[e];trigger(self.onCellCssStylesChanged,{key:e,hash:null})}function setCellCssStyles(e,o){var t=cellCssClasses[e];cellCssClasses[e]=o;updateCellCssStylesOnRenderedRows(o,t);trigger(self.onCellCssStylesChanged,{key:e,hash:o})}function getCellCssStyles(e){return cellCssClasses[e]}function flashCell(e,o,t){t=t||100;if(rowsCache[e]){var r=$(getCellNode(e,o));function n(e){if(!e){return}setTimeout(function(){r.queue(function(){r.toggleClass(options.cellFlashingCssClass).dequeue();n(e-1)})},t)}n(4)}}function handleDragInit(e,o){var t=getCellFromEvent(e);if(!t||!cellExists(t.row,t.cell)){return false}var r=trigger(self.onDragInit,o,e);if(e.isImmediatePropagationStopped()){return r}return false}function handleDragStart(e,o){var t=getCellFromEvent(e);if(!t||!cellExists(t.row,t.cell)){return false}var r=trigger(self.onDragStart,o,e);if(e.isImmediatePropagationStopped()){return r}return false}function handleDrag(e,o){return trigger(self.onDrag,o,e)}function handleDragEnd(e,o){trigger(self.onDragEnd,o,e)}function handleKeyDown(e){trigger(self.onKeyDown,{row:activeRow,cell:activeCell},e);var o=e.isImmediatePropagationStopped();var t=Slick.keyCode;if(!o){if(!e.shiftKey&&!e.altKey&&!e.ctrlKey){if(e.which==t.ESCAPE){if(!getEditorLock().isActive()){return}cancelEditAndSetFocus()}else if(e.which==t.PAGEDOWN){navigatePageDown();o=true}else if(e.which==t.PAGEUP){navigatePageUp();o=true}else if(e.which==t.LEFT){o=navigateLeft()}else if(e.which==t.RIGHT){o=navigateRight()}else if(e.which==t.UP){o=navigateUp()}else if(e.which==t.DOWN){o=navigateDown()}else if(e.which==t.TAB){o=navigateNext()}else if(e.which==t.ENTER){if(options.editable){if(currentEditor){if(activeRow===getDataLength()){navigateDown()}else{commitEditAndSetFocus()}}else{if(getEditorLock().commitCurrentEdit()){makeActiveCellEditable()}}}o=true}}else if(e.which==t.TAB&&e.shiftKey&&!e.ctrlKey&&!e.altKey){o=navigatePrev()}}if(o){e.stopPropagation();e.preventDefault();try{e.originalEvent.keyCode=0}catch(r){}}}function handleClick(e){if(!currentEditor){if(e.target!=document.activeElement||$(e.target).hasClass("slick-cell")){setFocus()}}var o=getCellFromEvent(e);if(!o||currentEditor!==null&&activeRow==o.row&&activeCell==o.cell){return}trigger(self.onClick,{row:o.row,cell:o.cell},e);if(e.isImmediatePropagationStopped()){return}if((activeCell!=o.cell||activeRow!=o.row)&&canCellBeActive(o.row,o.cell)){if(!getEditorLock().isActive()||getEditorLock().commitCurrentEdit()){scrollRowIntoView(o.row,false);setActiveCellInternal(getCellNode(o.row,o.cell))}}}function handleContextMenu(e){var o=$(e.target).closest(".slick-cell",$canvas);if(o.length===0){return}if(activeCellNode===o[0]&&currentEditor!==null){return}trigger(self.onContextMenu,{},e)}function handleDblClick(e){var o=getCellFromEvent(e);if(!o||currentEditor!==null&&activeRow==o.row&&activeCell==o.cell){return}trigger(self.onDblClick,{row:o.row,cell:o.cell},e);if(e.isImmediatePropagationStopped()){return}if(options.editable){gotoCell(o.row,o.cell,true)}}function handleHeaderMouseEnter(e){trigger(self.onHeaderMouseEnter,{column:$(this).data("column")},e)}function handleHeaderMouseLeave(e){trigger(self.onHeaderMouseLeave,{column:$(this).data("column")},e)}function handleHeaderContextMenu(e){var o=$(e.target).closest(".slick-header-column",".slick-header-columns");var t=o&&o.data("column");trigger(self.onHeaderContextMenu,{column:t},e)}function handleHeaderClick(e){var o=$(e.target).closest(".slick-header-column",".slick-header-columns");var t=o&&o.data("column");if(t){trigger(self.onHeaderClick,{column:t},e)}}function handleMouseEnter(e){trigger(self.onMouseEnter,{},e)}function handleMouseLeave(e){trigger(self.onMouseLeave,{},e)}function cellExists(e,o){return!(e<0||e>=getDataLength()||o<0||o>=columns.length)}function getCellFromPoint(e,o){var t=getRowFromPosition(o);var r=0;var n=0;for(var l=0;l<columns.length&&n<e;l++){n+=columns[l].width;r++}if(r<0){r=0}return{row:t,cell:r-1}}function getCellFromNode(e){var o=/l\d+/.exec(e.className);if(!o){throw"getCellFromNode: cannot get cell - "+e.className}return parseInt(o[0].substr(1,o[0].length-1),10)}function getRowFromNode(e){for(var o in rowsCache)for(var t in rowsCache[o].rowNode)if(rowsCache[o].rowNode[t]===e)return o|0;return null}function getFrozenRowOffset(e){var o=hasFrozenRows?options.frozenBottom?e>=actualFrozenRow?h<viewportTopH?actualFrozenRow*options.rowHeight:h:0:e>=actualFrozenRow?frozenRowsHeight:0:0;return o}function getCellFromEvent(e){var o,t;var r=$(e.target).closest(".slick-cell",$canvas);if(!r.length){return null}o=getRowFromNode(r[0].parentNode);if(hasFrozenRows){var n=r.parents(".grid-canvas").offset();var l=0;var i=r.parents(".grid-canvas-bottom").length;if(i){l=options.frozenBottom?Math.round($canvasTopL.height()):frozenRowsHeight}o=getCellFromPoint(e.clientX-n[xLeft],e.clientY-n.top+l+$(document).scrollTop()).row}t=getCellFromNode(r[0]);if(o==null||t==null){return null}else{return{row:o,cell:t}}}function getCellNodeBox(e,o){if(!cellExists(e,o)){return null}var t=getFrozenRowOffset(e);var r=getRowTop(e)-t;var n=r+options.rowHeight-1;var l=0;for(var i=0;i<o;i++){l+=columns[i].width;if(options.frozenColumn==i){l=0}}var a=l+columns[o].width;return rtl?{top:r,right:l,bottom:n,left:a}:{top:r,left:l,bottom:n,right:a}}function resetActiveCell(){setActiveCellInternal(null,false)}function setFocus(){if(tabbingDirection==-1){$focusSink[0].focus()}else{$focusSink2[0].focus()}}function scrollCellIntoView(e,o,t){if(o<=options.frozenColumn){return}if(e<actualFrozenRow){scrollRowIntoView(e,t)}var r=getColspan(e,o);var n=columnPosLeft[o],l=columnPosRight[o+(r>1?r-1:0)],i=scrollLeft+Math.round($viewportScrollContainerX.width());if(n<scrollLeft){$viewportScrollContainerX.scrollLeft(n);handleScroll();render()}else if(l>i){$viewportScrollContainerX.scrollLeft(Math.min(n,l-$viewportScrollContainerX[0].clientWidth));handleScroll();render()}}function setActiveCellInternal(e,o){if(activeCellNode!==null){makeActiveCellNormal();$(activeCellNode).removeClass("active");if(rowsCache[activeRow]){$(rowsCache[activeRow].rowNode).removeClass("active")}}var t=activeCellNode!==e;activeCellNode=e;if(activeCellNode!=null){var r=$(activeCellNode);var n=r.offset();var l=Math.floor(r.parents(".grid-canvas").offset().top);var i=r.parents(".grid-canvas-bottom").length;if(hasFrozenRows&&i){l-=options.frozenBottom?Math.round($canvasTopL.height()):frozenRowsHeight}cell=getCellFromPoint(n[xLeft],Math.ceil(n.top)-l);activeRow=cell.row;activeCell=activePosX=activeCell=activePosX=getCellFromNode(activeCellNode[0]);r.addClass("active");if(rowsCache[activeRow]){$(rowsCache[activeRow].rowNode).addClass("active")}if(o==null){o=activeRow==getDataLength()||options.autoEdit}if(options.editable&&o&&isCellPotentiallyEditable(activeRow,activeCell)){clearTimeout(h_editorLoader);if(options.asyncEditorLoading){h_editorLoader=setTimeout(function(){makeActiveCellEditable()},options.asyncEditorLoadDelay)}else{makeActiveCellEditable()}}}else{activeRow=activeCell=null}if(t){setTimeout(scrollActiveCellIntoView,50);trigger(self.onActiveCellChanged,getActiveCell())}}function clearTextSelection(){if(document.selection&&document.selection.empty){try{document.selection.empty()}catch(e){}}else if(window.getSelection){var o=window.getSelection();if(o&&o.removeAllRanges){o.removeAllRanges()}}}function isCellPotentiallyEditable(e,o){var t=getDataLength();if(e<t&&!getDataItem(e)){return false}if(columns[o].cannotTriggerInsert&&e>=t){return false}if(!getEditor(e,o)){return false}return true}function makeActiveCellNormal(){if(!currentEditor){return}trigger(self.onBeforeCellEditorDestroy,{editor:currentEditor});currentEditor.destroy();currentEditor=null;if(activeCellNode){var e=getDataItem(activeRow);$(activeCellNode).removeClass("editable invalid");if(e){var o=columns[activeCell];activeCellNode[0].innerHTML=callFormatter(activeRow,activeCell,getDataItemValueForColumn(e,o),o,e);invalidatePostProcessingResults(activeRow)}}if(navigator.userAgent.toLowerCase().match(/msie/)){clearTextSelection()}getEditorLock().deactivate(editController)}function makeActiveCellEditable(e){if(!activeCellNode){return}if(!options.editable){throw"Grid : makeActiveCellEditable : should never get called when options.editable is false"}clearTimeout(h_editorLoader);if(!isCellPotentiallyEditable(activeRow,activeCell)){return}var o=columns[activeCell];var t=getDataItem(activeRow);if(trigger(self.onBeforeEditCell,{row:activeRow,cell:activeCell,item:t,column:o})===false){setFocus();return}getEditorLock().activate(editController);$(activeCellNode).addClass("editable");if(!e){activeCellNode[0].innerHTML=""}currentEditor=new(e||getEditor(activeRow,activeCell))({grid:self,gridPosition:absBox($container[0]),position:absBox(activeCellNode[0]),container:activeCellNode,column:o,item:t||{},commitChanges:commitEditAndSetFocus,cancelChanges:cancelEditAndSetFocus});if(t){currentEditor.loadValue(t)}serializedEditorValue=currentEditor.serializeValue();if(currentEditor.position){handleActiveCellPositionChange()}}function commitEditAndSetFocus(){if(getEditorLock().commitCurrentEdit()){setFocus();if(options.autoEdit){navigateDown()}}}function cancelEditAndSetFocus(){if(getEditorLock().cancelCurrentEdit()){setFocus()}}function absBox(e){var o={top:e.offsetTop,bottom:0,width:$(e).outerWidth(),height:$(e).outerHeight(),visible:true};o[xLeft]=e.offsetLeft;o[xRight]=0;o.bottom=o.top+o.height;o[xRight]=o[xLeft]+o.width;var t=e.offsetParent;while((e=e.parentNode)!=document.body){if(o.visible&&e.scrollHeight!=e.offsetHeight&&$(e).css("overflowY")!="visible"){o.visible=o.bottom>e.scrollTop&&o.top<e.scrollTop+e.clientHeight}if(o.visible&&e.scrollWidth!=e.offsetWidth&&$(e).css("overflowX")!="visible"){o.visible=o[xRight]>e.scrollLeft&&o[xLeft]<e.scrollLeft+e.clientWidth}o[xLeft]-=e.scrollLeft;o.top-=e.scrollTop;if(e===t){o.right+=e.offsetLeft;o.top+=e.offsetTop;t=e.offsetParent}o.bottom=o.top+o.height;o[xRight]=o[xLeft]+o.width}return o}function getActiveCellPosition(){return absBox(activeCellNode[0])}function getGridPosition(){return absBox($container[0])}function handleActiveCellPositionChange(){if(!activeCellNode){return}trigger(self.onActiveCellPositionChanged,{});if(currentEditor){var e=getActiveCellPosition();if(currentEditor.show&&currentEditor.hide){if(!e.visible){currentEditor.hide()}else{currentEditor.show()}}if(currentEditor.position){currentEditor.position(e)}}}function getCellEditor(){return currentEditor}function getActiveCell(){if(!activeCellNode){return null}else{return{row:activeRow,cell:activeCell}}}function getActiveCellNode(){return activeCellNode}function scrollActiveCellIntoView(){if(activeRow!=null&&activeCell!=null){scrollCellIntoView(activeRow,activeCell)}}function scrollRowIntoView(e,o){if(!hasFrozenRows||!options.frozenBottom&&e>actualFrozenRow-1||options.frozenBottom&&e<actualFrozenRow-1){var t=Math.round($viewportScrollContainerY.height());var r=e*options.rowHeight;var n=(e+1)*options.rowHeight-t+(viewportHasHScroll?scrollbarDimensions.height:0);if((e+1)*options.rowHeight>scrollTop+t+offset){scrollTo(o?r:n);render()}else if(e*options.rowHeight<scrollTop+offset){scrollTo(o?n:r);render()}}}function scrollRowToTop(e){scrollTo(e*options.rowHeight);render()}function scrollPage(e){var o=e*numVisibleRows;scrollTo((getRowFromPosition(scrollTop)+o)*options.rowHeight);render();if(options.enableCellNavigation&&activeRow!=null){var t=activeRow+o;var r=getDataLengthIncludingAddNew();if(t>=r){t=r-1}if(t<0){t=0}var n=0,l=null;var i=activePosX;while(n<=activePosX){if(canCellBeActive(t,n)){l=n}n+=getColspan(t,n)}if(l!==null){setActiveCellInternal(getCellNode(t,l));activePosX=i}else{resetActiveCell()}}}function navigatePageDown(){scrollPage(1)}function navigatePageUp(){scrollPage(-1)}function getColspan(e,o){var t=data.getItemMetadata&&data.getItemMetadata(e);if(!t||!t.columns){return 1}var r=columns[o]&&(t.columns[columns[o].id]||t.columns[o]);var n=r&&r.colspan;if(n==="*"){n=columns.length-o}else{n=n||1}return n}function findFirstFocusableCell(e){var o=0;while(o<columns.length){if(canCellBeActive(e,o)){return o}o+=getColspan(e,o)}return null}function findLastFocusableCell(e){var o=0;var t=null;while(o<columns.length){if(canCellBeActive(e,o)){t=o}o+=getColspan(e,o)}return t}function gotoRight(e,o,t){if(o>=columns.length){return null}do{o+=getColspan(e,o)}while(o<columns.length&&!canCellBeActive(e,o));if(o<columns.length){return{row:e,cell:o,posX:o}}return null}function gotoLeft(e,o,t){if(o<=0){return null}var r=findFirstFocusableCell(e);if(r===null||r>=o){return null}var n={row:e,cell:r,posX:r};var l;while(true){l=gotoRight(n.row,n.cell,n.posX);if(!l){return null}if(l.cell>=o){return n}n=l}}function gotoDown(e,o,t){var r;var n=getDataLengthIncludingAddNew();while(true){if(++e>=n){return null}r=o=0;while(o<=t){r=o;o+=getColspan(e,o)}if(canCellBeActive(e,r)){return{row:e,cell:r,posX:t}}}}function gotoUp(e,o,t){var r;while(true){if(--e<0){return null}r=o=0;while(o<=t){r=o;o+=getColspan(e,o)}if(canCellBeActive(e,r)){return{row:e,cell:r,posX:t}}}}function gotoNext(e,o,t){if(e==null&&o==null){e=o=t=0;if(canCellBeActive(e,o)){return{row:e,cell:o,posX:o}}}var r=gotoRight(e,o,t);if(r){return r}var n=null;var l=getDataLengthIncludingAddNew();while(++e<l){n=findFirstFocusableCell(e);if(n!==null){return{row:e,cell:n,posX:n}}}return null}function gotoPrev(e,o,t){if(e==null&&o==null){e=getDataLengthIncludingAddNew()-1;o=t=columns.length-1;if(canCellBeActive(e,o)){return{row:e,cell:o,posX:o}}}var r;var n;while(!r){r=gotoLeft(e,o,t);if(r){break}if(--e<0){return null}o=0;n=findLastFocusableCell(e);if(n!==null){r={row:e,cell:n,posX:n}}}return r}function navigateRight(){return navigate("right")}function navigateLeft(){return navigate("left")}function navigateDown(){return navigate("down")}function navigateUp(){return navigate("up")}function navigateNext(){return navigate("next")}function navigatePrev(){return navigate("prev")}function navigate(e){if(!options.enableCellNavigation){return false}if(!activeCellNode&&e!="prev"&&e!="next"){return false}if(!getEditorLock().commitCurrentEdit()){return true}setFocus();var o={up:-1,down:1,prev:-1,next:1};tabbingDirection[xLeft]=-1;tabbingDirection[xRight]=1;tabbingDirection=o[e];var t={up:gotoUp,down:gotoDown,prev:gotoPrev,next:gotoNext};t[xLeft]=gotoLeft;t[xRight]=gotoRight;var r=t[e];var n=r(activeRow,activeCell,activePosX);if(n){if(hasFrozenRows&&options.frozenBottom&n.row==getDataLength()){return}var l=n.row==getDataLength();if(!options.frozenBottom&&n.row>=actualFrozenRow||options.frozenBottom&&n.row<actualFrozenRow){scrollCellIntoView(n.row,n.cell,!l)}setActiveCellInternal(getCellNode(n.row,n.cell));activePosX=n.posX;return true}else{setActiveCellInternal(getCellNode(activeRow,activeCell));return false}}function getCellNode(e,o){if(rowsCache[e]){ensureCellNodesInRowsCache(e);return rowsCache[e].cellNodesByColumnIdx[o]}return null}function setActiveCell(e,o){if(!initialized){return}if(e>getDataLength()||e<0||o>=columns.length||o<0){return}if(!options.enableCellNavigation){return}scrollCellIntoView(e,o,false);setActiveCellInternal(getCellNode(e,o),false)}function canCellBeActive(e,o){if(!options.enableCellNavigation||e>=getDataLengthIncludingAddNew()||e<0||o>=columns.length||o<0){return false}var t=data.getItemMetadata&&data.getItemMetadata(e);if(t&&typeof t.focusable==="boolean"){return t.focusable}var r=t&&t.columns;if(r&&columns[o]&&r[columns[o].id]&&typeof r[columns[o].id].focusable==="boolean"){return r[columns[o].id].focusable}if(r&&r[o]&&typeof r[o].focusable==="boolean"){return r[o].focusable}return columns[o].focusable}function canCellBeSelected(e,o){if(e>=getDataLength()||e<0||o>=columns.length||o<0){return false}var t=data.getItemMetadata&&data.getItemMetadata(e);if(t&&typeof t.selectable==="boolean"){return t.selectable}var r=t&&t.columns&&(t.columns[columns[o].id]||t.columns[o]);if(r&&typeof r.selectable==="boolean"){return r.selectable}return columns[o].selectable}function gotoCell(e,o,t){if(!initialized){return}if(!canCellBeActive(e,o)){return}if(!getEditorLock().commitCurrentEdit()){return}scrollCellIntoView(e,o,false);var r=getCellNode(e,o);setActiveCellInternal(r,t||e===getDataLength()||options.autoEdit);if(!currentEditor){setFocus()}}function commitCurrentEdit(){var e=getDataItem(activeRow);var o=columns[activeCell];if(currentEditor){if(currentEditor.isValueChanged()){var t=currentEditor.validate();if(t.valid){if(activeRow<getDataLength()){var r={row:activeRow,cell:activeCell,editor:currentEditor,serializedValue:currentEditor.serializeValue(),prevSerializedValue:serializedEditorValue,execute:function(){this.editor.applyValue(e,this.serializedValue);updateRow(this.row);trigger(self.onCellChange,{row:activeRow,cell:activeCell,item:e,grid:self})},undo:function(){this.editor.applyValue(e,this.prevSerializedValue);updateRow(this.row);trigger(self.onCellChange,{row:activeRow,cell:activeCell,item:e,grid:self})}};if(options.editCommandHandler){makeActiveCellNormal();options.editCommandHandler(e,o,r)}else{r.execute();makeActiveCellNormal()}}else{var n={};currentEditor.applyValue(n,currentEditor.serializeValue());makeActiveCellNormal();trigger(self.onAddNewRow,{item:n,column:o,grid:self})}return!getEditorLock().isActive()}else{$(activeCellNode).removeClass("invalid");$(activeCellNode).width();$(activeCellNode).addClass("invalid");trigger(self.onValidationError,{editor:currentEditor,cellNode:activeCellNode,validationResults:t,row:activeRow,cell:activeCell,column:o,grid:self});currentEditor.focus();return false}}makeActiveCellNormal()}return true}function cancelCurrentEdit(){makeActiveCellNormal();return true}function rowsToRanges(e){var o=[];var t=columns.length-1;for(var r=0;r<e.length;r++){o.push(new Slick.Range(e[r],0,e[r],t))}return o}function getSelectedRows(){if(!selectionModel){throw"Selection model is not set"}return selectedRows}function setSelectedRows(e){if(!selectionModel){throw"Selection model is not set"}selectionModel.setSelectedRanges(rowsToRanges(e))}this.debug=function(){var e="";e+="\n"+"counter_rows_rendered:  "+counter_rows_rendered;e+="\n"+"counter_rows_removed:  "+counter_rows_removed;e+="\n"+"renderedRows:  "+renderedRows;e+="\n"+"numVisibleRows:  "+numVisibleRows;e+="\n"+"maxSupportedCssHeight:  "+maxSupportedCssHeight;e+="\n"+"n(umber of pages):  "+n;e+="\n"+"(current) page:  "+page;e+="\n"+"page height (ph):  "+ph;e+="\n"+"vScrollDir:  "+vScrollDir;alert(e)};this.eval=function(expr){return eval(expr)};$.extend(this,{slickGridVersion:"2.1",onScroll:new Slick.Event,onSort:new Slick.Event,onHeaderMouseEnter:new Slick.Event,onHeaderMouseLeave:new Slick.Event,onHeaderContextMenu:new Slick.Event,onHeaderClick:new Slick.Event,onHeaderCellRendered:new Slick.Event,onBeforeHeaderCellDestroy:new Slick.Event,onHeaderRowCellRendered:new Slick.Event,onFooterRowCellRendered:new Slick.Event,onBeforeHeaderRowCellDestroy:new Slick.Event,onBeforeFooterRowCellDestroy:new Slick.Event,onMouseEnter:new Slick.Event,onMouseLeave:new Slick.Event,onClick:new Slick.Event,onDblClick:new Slick.Event,onContextMenu:new Slick.Event,onKeyDown:new Slick.Event,onAddNewRow:new Slick.Event,onValidationError:new Slick.Event,onViewportChanged:new Slick.Event,onColumnsReordered:new Slick.Event,onColumnsResized:new Slick.Event,onCellChange:new Slick.Event,onBeforeEditCell:new Slick.Event,onBeforeCellEditorDestroy:new Slick.Event,onBeforeDestroy:new Slick.Event,onActiveCellChanged:new Slick.Event,onActiveCellPositionChanged:new Slick.Event,onDragInit:new Slick.Event,onDragStart:new Slick.Event,onDrag:new Slick.Event,onDragEnd:new Slick.Event,onSelectedRowsChanged:new Slick.Event,onCellCssStylesChanged:new Slick.Event,registerPlugin:registerPlugin,unregisterPlugin:unregisterPlugin,getColumns:getColumns,setColumns:setColumns,getColumnIndex:getColumnIndex,updateColumnHeader:updateColumnHeader,setSortColumn:setSortColumn,setSortColumns:setSortColumns,getSortColumns:getSortColumns,autosizeColumns:autosizeColumns,getOptions:getOptions,setOptions:setOptions,getData:getData,getDataLength:getDataLength,getDataItem:getDataItem,setData:setData,getSelectionModel:getSelectionModel,setSelectionModel:setSelectionModel,getSelectedRows:getSelectedRows,setSelectedRows:setSelectedRows,getContainerNode:getContainerNode,render:render,invalidate:invalidate,invalidateRow:invalidateRow,invalidateRows:invalidateRows,invalidateAllRows:invalidateAllRows,updateCell:updateCell,updateRow:updateRow,getViewport:getVisibleRange,getRenderedRange:getRenderedRange,resizeCanvas:resizeCanvas,updateRowCount:updateRowCount,scrollRowIntoView:scrollRowIntoView,scrollRowToTop:scrollRowToTop,scrollCellIntoView:scrollCellIntoView,getCanvasNode:getCanvasNode,getCanvases:getCanvases,getActiveCanvasNode:getActiveCanvasNode,setActiveCanvasNode:setActiveCanvasNode,getViewportNode:getViewportNode,getActiveViewportNode:getActiveViewportNode,setActiveViewportNode:setActiveViewportNode,focus:setFocus,getCellFromPoint:getCellFromPoint,getCellFromEvent:getCellFromEvent,getActiveCell:getActiveCell,setActiveCell:setActiveCell,getActiveCellNode:getActiveCellNode,getActiveCellPosition:getActiveCellPosition,resetActiveCell:resetActiveCell,editActiveCell:makeActiveCellEditable,getCellEditor:getCellEditor,getCellNode:getCellNode,getCellNodeBox:getCellNodeBox,canCellBeSelected:canCellBeSelected,canCellBeActive:canCellBeActive,navigatePrev:navigatePrev,navigateNext:navigateNext,navigateUp:navigateUp,navigateDown:navigateDown,navigateLeft:navigateLeft,navigateRight:navigateRight,navigatePageUp:navigatePageUp,navigatePageDown:navigatePageDown,gotoCell:gotoCell,getTopPanel:getTopPanel,setTopPanelVisibility:setTopPanelVisibility,setHeaderRowVisibility:setHeaderRowVisibility,getHeaderRow:getHeaderRow,getHeaderRowColumn:getHeaderRowColumn,setFooterRowVisibility:setFooterRowVisibility,getFooterRow:getFooterRow,getFooterRowColumn:getFooterRowColumn,getGridPosition:getGridPosition,flashCell:flashCell,addCellCssStyles:addCellCssStyles,setCellCssStyles:setCellCssStyles,removeCellCssStyles:removeCellCssStyles,getCellCssStyles:getCellCssStyles,getFrozenRowOffset:getFrozenRowOffset,groupTotalsFormatter:groupTotalsFormatter,updateFooterTotals:updateFooterTotals,init:finishInitialization,destroy:destroy,getEditorLock:getEditorLock,getEditController:getEditController});init()}})(jQuery);